<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# alue tarkastusfunktiot

function alue_ok(&$msg,$id,$alue) {
  global $table;
  
  $msg = '';
  $ret = 0;
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # tytyy kuitenkin olla pkyttj.
   
  if ($alue == '') {
    $msg = 'Alue on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # duplikaatit
  $dup =
    ota_yksi("SELECT id
              FROM $table
              WHERE alue = '$alue'
              $id_sql");
  if ($dup != '') {
    $msg = "Tllainen alue on jo olemassa (id=$dup).";
    $msg .= $tail;
    return 2;
  } 

  return $ret;
}

function alue_add_ok(&$msg,$alue) {
  return alue_ok($msg,'',$alue);
}

function alue_save_ok(&$msg,$id,$alue) {
  return alue_ok($msg,$id,$alue);
}

function alue_remove_ok(&$msg, $id, $log = true) {
  global $table;
  
  $ret = 0;

  if ($id <= 3) {
    $msg = "Alueet 1-3 on suojattu eik niit voi poistaa.";
    return 2;
  }

  # jos viittauksia, bzz
  $tabs = array('kayttajat_alue', 'paivystys', 'paikka', 'ryhma_tila',
		'ryhma', 'jarjesto', 'hlo_tila', 'hlo', 'tap',
		'kadonnut', 'loytynyt', 'loki', 'laite', 'tavara');
  foreach ($tabs as $tab) {
    $ref =
      ota_yksi("SELECT COUNT(*) FROM $tab WHERE alue_id = $id");
    if ($ref != 0) {
      $msg = "Thn alueeseen on $ref viittausta taulussa $tab. Sit ei voi"
	. " poistaa ennen kuin viittaukset on siivottu.";
      return 2;
    }
  }
  $ref =
    ota_yksi("SELECT COUNT(*)
              FROM hlo_ajat
              WHERE variable_id = $id AND hlo_ajat_tyyppi_id = 3");
  if ($ref != 0) {
    $msg = "Thn alueeseen on $ref viittausta taulussa hlo_ajat. Sit ei voi"
      . " poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }

  return $ret;
}

?>

<!-- RCS $Id: alue-ok.php,v 1.4 2009/06/06 14:11:15 riku Exp $ -->
