<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# emit debug message to syslog if config_debug is greater or equal to
# given limit

function debug($limit,$msg) {
  global $config_debug;

  if ($config_debug >= $limit)
    syslog  (LOG_DEBUG, $msg);
}

function clean_nro($input) {
  $output = '';
  for ($i = 0; $i < strlen($input); $i ++) {
    $x = $input{$i};
    if (strstr("0123456789", $x)) {
      $output .= $x;
    }
  }
  return $output;
}

function get_nro($g) {
  return clean_nro($_GET[$g]);
}

function post_nro($g) {
  return clean_nro($_POST[$g]);
}

# oletusarvolla, "" => "0"

function get_nro_0($g) {
  $output = get_nro($g);
  if ($output == "") { $output = "0"; }
  return $output;
}

function post_nro_0($g) {
  $output = post_nro($g);
  if ($output == "") { $output = "0"; }
  return $output;
}

function get_nro_1($g) {
  $output = get_nro($g);
  if ($output == "") { $output = "1"; }
  return $output;
}

function get_multi_nro($g) {
  $tmp = $_GET[$g];
  $ret = array();

  if ($tmp) {
    foreach ($tmp as $t) {
      $ret[] = clean_nro($t);
    }
  }

  return $ret;
}

function post_multi_nro($g) {
  $tmp = $_POST[$g];
  $ret = array();

  if ($tmp) {
    foreach ($tmp as $t) {
      $ret[] = clean_nro($t);
    }
  }

  return $ret;
}

$valid_user
= ' 0123456789'
. 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
. 'abcdefghijklmnopqrstuvwxyz'
. ''
;

function clean_user($input) {
  global $valid_user;
  
  $output = '';
  for ($i = 0; $i < strlen($input); $i ++) {
    $x = $input{$i};
    if (strstr($valid_user, $x)) {
      $output .= $x;
    }
  }
  return $output;
}

$valid_txt 
= ' !()*+-.,/0123456789:;<=>?@'
. 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
. 'abcdefghijklmnopqrstuvwxyz'
. ''
;

function clean_txt($input) {
  global $valid_txt;
  
  $output = '';
  for ($i = 0; $i < strlen($input); $i ++) {
    $x = $input{$i};
    if (strstr($valid_txt, $x)) {
      $output .= $x;
    }
  }
  return $output;
}

function get_txt($g) {
  return clean_txt($_GET[$g]);
}

function post_txt($g) {
  return clean_txt($_POST[$g]);
}

function nayta_operaatio($p_id)
{
  global $prefix;

  if ($p_id == 1) {
    # neutraali
    return "EI MIKN";
  } 

  $nimi = ota_yksi("SELECT nimi FROM paivystys WHERE id = $p_id");

  if ($p_id == s('paivystys')) {
    # 'oma' henkil
    return "<font color=green>$nimi</font>";
  }
  
  # 'vieras' henkil
  return "<font color=red>$nimi</font>";

}

# Jos kaapataan toisen pivystyksen henkil, laitetaan tiedoksi
function ilmoita_jos_tarpeen($h_id)
{
  global $prefix;
  
  $p_id = ota_yksi("SELECT paivystys_id FROM hlo WHERE id = $h_id");
  if ($p_id != 0 && $p_id != s('paivystys')) {
    taktinen_loki_paivystys($p_id,
			    ota_nimi($h_id)
			    . " otettu operaatioon "
			    . ota_paivystys_nimi());
  }
}

# sama laitteelle
function ilmoita_laite_jos_tarpeen($l_id)
{
  global $prefix;
  
  $p_id = ota_yksi("SELECT paivystys_id FROM laite WHERE id = $l_id");
  if ($p_id != 0 && $p_id != s('paivystys')) {
    taktinen_loki_paivystys($p_id,
			    laite_tunniste($l_id)
			    . " otettu operaatioon "
			    . ota_paivystys_nimi());
  }
}

# ja tavaralle
function ilmoita_tavara_jos_tarpeen($t_id)
{
  global $prefix;
  
  $p_id = ota_yksi("SELECT paivystys_id FROM tavara WHERE id = $t_id");
  if ($p_id != 0 && $p_id != s('paivystys')) {
    taktinen_loki_paivystys($p_id,
			    tavara_tunniste($t_id)
			    . " otettu operaatioon "
			    . ota_paivystys_nimi());
  }
}

function muotoile_koordinaatit($k) {
  if ($k == '') { return ''; }
  return ' [ ' . $k . ' ]';
}

function muotoile_verkko($v, $ryhma_id) {
  if ($v == '' || $ryhma_id == 1) { return ''; }
  $mv_oletus_verkko = ota_oletus_verkko();
  if ($v == $mv_oletus_verkko) { return ''; }
  return ' [ ' . $v . ' ]';
}

function muotoile_verkko_paivystys($v, $ryhma_id, $paivystys_id) {
  if ($v == '' || $ryhma_id == 1) { return ''; }
  $mv_oletus_verkko = ota_yksi ("
SELECT verkko
FROM verkko,paivystys
WHERE oletus_verkko_id = verkko.id AND paivystys.id = $paivystys_id
");
  if ($v == $mv_oletus_verkko) { return ''; }
  return ' [ ' . $v . ' ]';
}

function taktiset_linkit() {
  print "<p>

<a href=\"index.php\">VIHAn psivulle</a>

<br>
Tilanne: <a href=\"tilanne.php\">yleinen</a>, 
<a href=\"tilanne-taysi.php\">ryhmt, miehitykset ja tapahtumat</a>, 
<a href=\"tilanne-kalusto.php\">kalusto</a>, 
<a href=\"lapset-taysi.php\">kadonneet ja lytyneet henkilt</a>,
<a href=\"taktinen-loki.php\">pivkirja</a>,
<a href=\"tyotunnit.php\">tunnit</a>.

<br>
Pivitykset: 
<a href=\"ryhma-takt.php\">ryhmn</a>, 
<a href=\"hlo-takt.php\">henkiln</a>,
<a href=\"tap-takt.php\">tapahtumakirjaus</a>,
<a href=\"hlo-oper.php\">miehittminen</a>,
<a href=\"jarjesto-takt.php\">hlytysryhmt</a>.

<br>
Varustaminen:
<a href=\"laite-oper.php\">operaation</a>,
<a href=\"kalusto-takt.php\">ryhmien</a>.

<br>
Henkilt: 
<a href=\"kadonnut.php\">kateissa olevat</a>, 
<a href=\"loytynyt.php\">lytyneet</a>.

";
}

function hallinnolliset_linkit() {
  global $prefix;
  
  taktiset_linkit();
  echo "<br>
Ksittely: 
<a href=\"tap.php\">tapahtumat</a>, 
<a href=\"hlo.php\">henkilt</a>,
<a href=\"ryhma.php\">ryhmt</a>,
<a href=\"verkko.php\">verkot</a>, ";
  if (s('paivystys') == 0) {
    echo "<a href=\"paivystys.php\">perustiedot</a>, ";
    echo "<a href=\"kayttajat.php\">kyttjt</a>, ";
  }
  echo "<a href=\"jarjesto.php\">jrjestt</a>,\n";
  echo "<a href=\"laite.php\">viestivlineet</a>,\n";
  echo "<a href=\"tavara.php\">muu kalusto</a>\n";
}

function vain_hhmm ($aika)
{
  #             0123456789012345678
  #                        12345
  #                  12345678901
  #             1234567890123456
  if ($aika == '0000-00-00 00:00:00') {
    return '';
  }
  $diff = ota_yksi("SELECT DATEDIFF(NOW(), '$aika')");
  if ($diff == 0) {
    return substr($aika, 11, 5);
  } elseif ($diff < 200) {
    return substr($aika, 5, 11);
  } else {
    return substr($aika, 0, 16);
  }
}

function s_hhmmss($s) {
  $h = (int)($s / 3600);
  $r = $s - $h * 3600;
  $m = (int)($r / 60);
  $r = $r - $m * 60;

  return sprintf("%02d:%02d:%02d", $h, $m, $r);
}

function m_ddhhmm($m) {
  $ret = '';
  
  $d = (int)($m / (60*24));
  $r = $m - $d * (60*24);
  $h = (int)($r / 60);
  $r = $r - $h * 60;

  if ($d > 0)
    $ret .= sprintf("%d:",$d);

  if ($h > 0)
    $ret .= sprintf("%02d:",$h);

  $ret .= sprintf("%02d", $r);

  return $ret;
}

$ts_regex = '/^[0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9] [0-9][0-9]:[0-9][0-9]:[0-9][0-9]$/';

# check validity of timestamp, 0==ok, 2==invalid
# could be better

function timestamp_ok($ts) {
  global $ts_regex;
  
  if ($ts == '')
    return 0;
  
  if (preg_match($ts_regex, $ts))
    return 0;

  return 2;
}

function maaginen_kello ($klo)
{
  global $ts_regex;
  
  if (($klo == '') || ($klo == '0000-00-00 00:00:00')) {
    return '';
  }
  if (preg_match($ts_regex, $klo)) {
    return $klo;
  }
  $timestamp = time();
  if (preg_match('/^[0-9][0-9]:[0-9][0-9]$/', $klo)) {
    return date("Y-m-d", $timestamp) . " " . $klo . ":00";
  }
  $offset = 0;
  if (preg_match("/^[+-]\d+$/", $klo)) {
    $offset = preg_replace("/(\d+)/", "$1", $klo);
    $timestamp += $offset * 60;
  }
  return date("Y-m-d H:i:s", $timestamp);
}

function my_mysql_query ($sql, $log_error = true, $log_sql = false) {
  $ret = mysql_query($sql);
  if (! $ret) {
    $herja = mysql_error();
    if ($log_error)
      loki("my_mysql_query: failed: $sql: $herja");
    die("<p>Invalid query sql=$sql: $herja");
  }
  if ($log_sql)
    loki($sql);
  return $ret;
}

function remote_user() {
  global $username;

  return $username;
}

function loki ($data)
{
  global $prefix;

  $now = date('Y-m-d H:i:s');
  $ip = $_SERVER['REMOTE_ADDR'];
  $alue = s('alue');
  if ($alue == 0) $alue = 1;
  $paivystys = s('paivystys');
  if ($paivystys == 0) $paivystys = 1;
  $user = remote_user();
  $data = str_replace("\n", " ", $data);
  $data = str_replace("'", "\'", $data);
  $data = substr($data,0,512);
  if (substr($data,-1,1) == "\\")
    $data = substr($data,0,511);
  $sql =
    "INSERT INTO loki
     SET alue_id = $alue,
         paivystys_id = $paivystys,
         data = '$data',
         ip = '$ip',
         user = '$user',
         ts = '$now'";
  $result = my_mysql_query ($sql,false,false);
}

function taktinen_loki_paivystys ($p_id, $data)
{
  $now = date('Y-m-d H:i:s');
  $ip = $_SERVER['REMOTE_ADDR'];
  $user = remote_user();
  $uusi_id = ota_yksi("
SELECT MAX(id)
FROM taktinen_loki
WHERE paivystys_id = $p_id
");
  $uusi_id += 1;
  $sql = "
INSERT INTO taktinen_loki
VALUES ($uusi_id, $p_id, '$data', '$ip', '$user', '$now')
";
  $result = my_mysql_query ($sql);
}

function taktinen_loki ($data)
{
  global $prefix;
  
  taktinen_loki_paivystys(s('paivystys'), $data);
}

#
# Tarkastetaan, onko annetulle kutsujalle jo tehty sama homma.
# Palautetaan 0 jos on, muuten 1.
#
function saa_tehda($kuka)
{
  global $prefix;
  
  $ip = $_SERVER['REMOTE_ADDR'];
  $user = remote_user();
  $md5 = md5($_SERVER['REQUEST_URI']);
  $n =
    ota_yksi("SELECT COUNT(*)
              FROM suoja
              WHERE kuka = '$kuka'
                    AND ip = '$ip'
                    AND user = '$user'
                    AND md5 = '$md5'
                    AND paivystys_id = " . s("paivystys"));
  if ($n > 0) {
    # Reject, done before. No need for anything else.
    loki("DENIED saa_tehda kuka=$kuka ip=$ip user=$user md5=$md5 paivystys_id="
	 . s("paivystys"));
    return 0;
  } 

  # Accept it, not done before. Clean old tracks and note the fact.
  $now = date('Y-m-d H:i:s');
  my_mysql_query("
DELETE
FROM suoja
WHERE kuka = '$kuka' AND ip = '$ip' AND user = '$user'
      AND paivystys_id = " . s("paivystys"));
  my_mysql_query("
INSERT
INTO suoja
VALUES ('$kuka', '$md5', '$ip', '$user', "
		 . s("paivystys") . ", '$now')
");

  return 1;

}

function ota_yksi ($sql,$log=true)
{
  $ret = 0;
  $result = my_mysql_query ($sql,$log);
  if ($result) {
    $data = mysql_fetch_row($result);
    $ret = $data[0];    
  }
  return $ret;
}

function ota_yksi_0 ($sql, $id, $nolla)
{
  if ($id == 0) {
    return $nolla;
  }
  $ret = 0;
  $result = my_mysql_query ($sql);
  if ($result) {
    $data = mysql_fetch_row($result);
    $ret = $data[0];    
  }
  return $ret;
}

function ota_oletus_verkko()
{
  global $prefix;
  
  return
    ota_yksi ("SELECT verkko
               FROM verkko,paivystys
               WHERE oletus_verkko_id = verkko.id
                     AND paivystys.id = " . s("paivystys"));
}

function ota_oletus_verkko_id()
{
  global $prefix;
  
  return
    ota_yksi ("SELECT verkko.id
               FROM verkko,paivystys
               WHERE oletus_verkko_id = verkko.id
                     AND paivystys.id = " . s("paivystys"));
}

function ota_vahvuus($p_id)
{
  return ota_yksi ("SELECT COUNT(*) FROM hlo WHERE paivystys_id = $p_id");
}

function ota_paikalla($p_id)
{
  return
    ota_yksi ("SELECT COUNT(*)
               FROM hlo
               WHERE paivystys_id = $p_id
                     AND hlo_tila_id IN (SELECT id
                                         FROM hlo_tila
                                         WHERE paikalla = 1)");
}

function ota_paivystys_nimi()
{
  global $prefix;
  
  return
    ota_yksi("SELECT nimi
              FROM paivystys
              WHERE id = " . s("paivystys"));
}

function ota_verkko($id)
{
  return ota_yksi("SELECT verkko FROM verkko WHERE id = $id");
}

function jarjesto($id)
{
  return ota_yksi("SELECT jarjesto FROM jarjesto WHERE id = $id");
}

function jarjesto_personal($id)
{
  $ret = ota_yksi("SELECT jarjesto FROM jarjesto WHERE id = $id");
  if ($id == "1") { $ret = "HENKILKOHTAINEN"; }
  return $ret;
}

function ota_paikka($id)
{
  return ota_yksi("SELECT paikka FROM paikka WHERE id = $id");
}

function ota_nimi($id)
{
  return ota_yksi("SELECT nimi FROM hlo WHERE id = $id");
}

function laite_tunniste($id)
{
  $ret = ota_yksi("SELECT laite FROM laite WHERE id = $id");
  $add = ota_yksi("SELECT tunniste FROM laite WHERE id = $id");
  if ($add !== '') 
    $ret = "$ret($add)";

  return $ret;
}

function tavara_tunniste($id)
{
  $ret = ota_yksi("SELECT tavara FROM tavara WHERE id = $id");
  $add = ota_yksi("SELECT tunniste FROM tavara WHERE id = $id");
  if ($add !== '') 
    $ret = "$ret($add)";

  return $ret;
}

function ota_tap($id)
{
  return ota_yksi("SELECT tap FROM tap WHERE id = $id");
}

function ota_kutsu($ryhma_id)
{
  return ota_yksi("SELECT kutsu FROM ryhma WHERE id = $ryhma_id");
}

function ota_hlo_tila($hlo_tila_id)
{
  return ota_yksi("SELECT hlo_tila FROM hlo_tila WHERE id = $hlo_tila_id");
}

function ota_hlo_asema($hlo_asema_id)
{
  return ota_yksi("SELECT hlo_asema FROM hlo_asema WHERE id = $hlo_asema_id");
}

function ota_ryhma_tila($id)
{
  return ota_yksi("SELECT ryhma_tila FROM ryhma_tila WHERE id = $id");
}

function ota_lapsi_tila($id)
{
  return ota_yksi("SELECT lapsi_tila FROM lapsi_tila WHERE id = $id");
}

function ota_kadonnut_nimi($id)
{
  return ota_yksi("SELECT nimi FROM kadonnut WHERE id = $id");
}

function ota_loytynyt_nimi($id)
{
  return ota_yksi("SELECT nimi FROM loytynyt WHERE id = $id");
}

function ota_kadonneet_paivystys($p_id)
{
  return ota_yksi("
SELECT COUNT(*)
FROM kadonnut
WHERE (paivystys_id = 0 OR paivystys_id = $p_id)
");
}

function ota_kadonneet()
{
  global $prefix;
  
  return ota_kadonneet_paivystys(s('paivystys'));
}

function ota_loytyneet_paivystys($p_id)
{
  return ota_yksi("
SELECT COUNT(*)
FROM loytynyt
WHERE (paivystys_id = 0 OR paivystys_id = $p_id)
");
}

function ota_loytyneet()
{
  global $prefix;
  
  return ota_loytyneet_paivystys(s('paivystys'));
}

function ota_oletus_ryhma_paivystys()
{
  global $prefix;
  
  return
    ota_yksi("SELECT MIN(id)
              FROM ryhma
              WHERE paivystys_id = 0
                    OR paivystys_id = " . s("paivystys"));
}

function last_insert_id ()
{
  return ota_yksi ("SELECT LAST_INSERT_ID()");
}

function tee_valinta($variable, $current_value, $table, $id_col, $label_col,
		     $extra_sql)
{
  print "<select name=\"$variable\">\n";

  $sql = "SELECT $id_col, $label_col FROM $table $extra_sql";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      print ">$option_label\n";
    }
  }
  
  print "</select>\n";
}

# tehdn valinta tietylle henkillle sopivista henkiln tilakoodeista.
# valitaan tilakoodit, jotka
# 1) ovat yleisi,
# 2) kuuluvat henkiln alueeseen tai
# 3) kuuluvat henkiln operaatioon

function select_hlo_tila_for_hlo($hlo_tila_id,$hlo_id)
{
  $alue_id = tab_col_id("hlo","alue_id",$hlo_id);
  $paivystys_id = tab_col_id("hlo","paivystys_id",$hlo_id);
  print "<select name=\"hlo_tila_id\">\n";

  $sql = "
SELECT id, hlo_tila
FROM hlo_tila
WHERE alue_id = 2
      OR (alue_id = $alue_id AND paivystys_id = 2)
      OR paivystys_id = $paivystys_id
ORDER BY hlo_tila
";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      print "<option value=\"$option_value\"";
      if ($option_value == $hlo_tila_id) { print " selected"; }
      print ">$option_label\n";
    }
  }
  
  print "</select>\n";
}

function tee_valinta_paivystys($variable, $current_value, $table, $id_col,
			       $label_col, $extra_sql)
{
  global $prefix;
  
  $sql =
    "SELECT $id_col, $label_col
     FROM $table
     WHERE (paivystys_id = 0) OR (paivystys_id = " . s("paivystys") . ")
     $extra_sql";
  $result = my_mysql_query($sql);
  print "<select name=\"$variable\">\n";
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      print ">$option_label\n";
    }
  }
  
  print "</select>\n";
}

# onko nykyisell kyttjll oikeus tiettyyn operaatioon?

function paivystys_id_ok(&$msg,$id) {
  global $table, $userlevel_no, $prefix;
  
  $msg = '';
  
  if ($id == '') {
    $msg = "Tuntematon operaatio.";
    return 2;
  }

  # oltava olemassa
  if (tab_col_id("paivystys","id",$id) == '') {
    $msg = "Operaatiota $id ei lydy.";
    return 2;
  }

  # oltava oikeus.
  # paakayttaja?
  if ($userlevel_no > 25)
    return 0;

  # oikeus thn operaatioon?
  if (ota_yksi("SELECT COUNT(*)
                FROM kayttajat_paivystys
                WHERE paivystys_id = $id
                      AND kayttajat_id = " . s("userid")) != 0)
    return 0;

  # aluevastaava?
  $paivystys_alue_id = tab_col_id("paivystys","alue_id",$id);
  if (ota_yksi("SELECT COUNT(*)
                FROM kayttajat_alue
                WHERE alue_id = $paivystys_alue_id
                      AND kayttajat_id = " . s("userid")) != 0)
    return 0;

  $msg =
    "Kyttjll " . s("userid") . " ei ole oikeutta"
    . " operaatioon $paivystys_id";
  return 2;
}

# tehdn valintalista operaatioista joihin meill on oikeus. mukaan mys
# 1(ei operaatiota).

function select_paivystys($current_value)
{
  $sql =
    "SELECT id, nimi
     FROM paivystys
     ORDER by nimi";
  $result = my_mysql_query($sql);
  print "<select name=\"paivystys_id\">\n";
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      if ($option_value <= 2 || paivystys_id_ok($herja,$option_value) != 2) {
	print "<option value=\"$option_value\"";
	if ($option_value == $current_value)
	  print " selected";
	print ">$option_label\n";
      }
    }
  }
  
  print "</select>\n";
}

# tehdn valintalista oikeista operaatioista joihin meill on oikeus.

function select_paivystys_real($current_value)
{
  $sql =
    "SELECT id, nimi
     FROM paivystys
     ORDER by nimi";
  $result = my_mysql_query($sql);
  print "<select name=\"paivystys_id\">\n";
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      if ($option_value > 2 && paivystys_id_ok($herja,$option_value) != 2) {
	print "<option value=\"$option_value\"";
	if ($option_value == $current_value)
	  print " selected";
	print ">$option_label\n";
      }
    }
  }
  
  print "</select>\n";
}

# tehdn valintalista jossa on valittavan tiedon lisksi operaatio

function tee_valinta_plus_paivystys($variable, $current_value, $table,
				    $id_col, $label_col, $extra_sql)
{
  print "<select name=\"$variable\">\n";

  $sql = "SELECT $id_col, $label_col FROM $table $extra_sql";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      $paivystys_id = ota_yksi("SELECT paivystys_id FROM $table WHERE id = $option_value");
      $lisa_label = '';
      if ($paivystys_id != 0) {
	$lisa_label = ' [ ' . ota_yksi("SELECT nimi FROM paivystys WHERE id = $paivystys_id") . ' ]';
      }
      print ">$option_label$lisa_label\n";
    }
  }
  
  print "</select>\n";
}

# onko nykyisell kyttjll oikeus tiettyyn alueeseen?

function alue_id_ok(&$msg,$id) {
  global $userlevel_no, $prefix;
  
  $table = "alue";
  
  $msg = '';
  
  if ($id == '') {
    $msg = "Tuntematon alue.";
    return 2;
  }

  # oltava olemassa
  if (tab_col_id("alue","id",$id) == '') {
    $msg = "Aluetta $id ei lydy.";
    return 2;
  }

  # pikakaista.
  if ($id == s('alue'))
    return 0;

  # oltava oikeus.
  # paakayttaja?
  if ($userlevel_no > 25)
    return 0;

  # aluevastaava?
  if (ota_yksi("SELECT COUNT(*)
                FROM kayttajat_alue
                WHERE alue_id = $id
                      AND kayttajat_id = " . s("userid")) != 0)
    return 0;

  $msg =
    "Kyttjll " . s("userid") . " ei ole oikeutta alueeseen $id";
  return 2;
}

# Tehdn alueista valintalista. Listaan kelpuutetaan alueet, jotka
# meille nkyvt (vhintn sessiosta otettu alue sek 1 ja 2)

function select_alue($current_value)
{
  print "<select name=\"alue_id\">\n";

  $sql =
    "SELECT id, alue
     FROM alue
     ORDER BY alue";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      if ($option_value <= 2 || alue_id_ok($herja,$option_value) != 2) {
	print "<option value=\"$option_value\"";
	if ($option_value == $current_value)
	  print " selected";
	print ">$option_label\n";
      }
    }
  }
  
  print "</select>\n";
}

# tehdn ryhmist valintalista jossa on valittavan tiedon lisksi alue
# ja operaatio. operaatiot valitaan kyttjn oikeuksien mukaan.

function select_ryhma_full($current_value)
{
  global $userid, $prefix;
  
  print "<select name=\"ryhma_id\">\n";

  if (is_superuser($userid))
    $where = "";
  else
    $where =
      "WHERE alue_id = 2
             OR (alue_id = " . s("alue") . " AND paivystys_id = 2)
             OR paivystys_id = " . s("paivystys") . "
             OR paivystys_id IN (SELECT paivystys_id
                                 FROM kayttajat_paivystys
                                 WHERE kayttajat_id = $userid)
             OR alue_id IN  (SELECT alue_id
                             FROM kayttajat_alue
                             WHERE kayttajat_id = $userid)";
  $sql =
    "SELECT id, kutsu, alue_id, paivystys_id
     FROM ryhma
     $where
     ORDER BY alue_id,paivystys_id,pri";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      $alue_id = $data[2];
      $paivystys_id = $data[3];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      $paivystys_label = tab_col_id("paivystys","nimi",$paivystys_id);
      $alue_label = tab_col_id("alue","",$alue_id);
      $lisa_label = " [$alue_label, $paivystys_label]";
      print ">$option_label$lisa_label\n";
    }
  }
  
  print "</select>\n";
}

# tehdn sijainneista valintalista jossa on valittavan tiedon lisksi alue
# ja operaatio. operaatiot valitaan kyttjn oikeuksien mukaan.

function select_paikka_full($current_value)
{
  global $userid, $prefix;
  
  print "<select name=\"paikka_id\">\n";

  if (is_superuser($userid))
    $where = "";
  else
    $where =
      "WHERE alue_id = 2
             OR (alue_id = " . s("alue") . " AND paivystys_id = 2)
             OR paivystys_id = " . s("paivystys") . "
             OR paivystys_id IN (SELECT paivystys_id
                                 FROM kayttajat_paivystys
                                 WHERE kayttajat_id = $userid)
             OR alue_id IN  (SELECT alue_id
                             FROM kayttajat_alue
                             WHERE kayttajat_id = $userid)";

  $sql =
    "SELECT id, paikka, alue_id, paivystys_id
     FROM paikka
     $where
     ORDER BY alue_id, paivystys_id, paikka";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      $alue_id = $data[2];
      $paivystys_id = $data[3];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      $paivystys_label = tab_col_id("paivystys","nimi",$paivystys_id);
      $alue_label = tab_col_id("alue","",$alue_id);
      $lisa_label = " [$alue_label, $paivystys_label]";
      print ">$option_label$lisa_label\n";
    }
  }
  
  print "</select>\n";
}

# tehdn ryhmn tilakoodeista valintalista jossa on valittavan tiedon lisksi
# alue ja operaatio. operaatiot valitaan kyttjn oikeuksien mukaan.

function select_ryhma_tila_full($current_value)
{
  global $userid;
  
  print "<select name=\"ryhma_tila_id\">\n";

  if (is_superuser($userid))
    $limiter_sql = "";
  else
    $limiter_sql =
      "WHERE paivystys_id = 2
             OR alue_id = 2
             OR paivystys_id IN (SELECT paivystys_id
                                 FROM kayttajat_paivystys
                                 WHERE kayttajat_id = $userid)
             OR alue_id IN  (SELECT alue_id
                             FROM kayttajat_alue
                             WHERE kayttajat_id = $userid)";

  $sql =
    "SELECT id, ryhma_tila, alue_id, paivystys_id
     FROM ryhma_tila
     $limiter_sql
     ORDER BY alue_id, paivystys_id, ryhma_tila";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      $alue_id = $data[2];
      $paivystys_id = $data[3];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      $paivystys_label = tab_col_id("paivystys","nimi",$paivystys_id);
      $alue_label = tab_col_id("alue","",$alue_id);
      $lisa_label = " [$alue_label, $paivystys_label]";
      print ">$option_label$lisa_label\n";
    }
  }
  
  print "</select>\n";
}

# Tehdn ryhmist valintalista. Listaan kelpuutetaan ryhmt, jotka
# kuuluvat valittuun operaatioon tai ovat sellaisia, jotka nkyvt kaikille.

function select_ryhma($current_value)
{
  global $prefix;
  
  print "<select name=\"ryhma_id\">\n";

  $sql =
    "SELECT id, kutsu
     FROM ryhma
     WHERE alue_id = 2
           OR (alue_id = " . s("alue") . " AND paivystys_id = 2)
           OR (paivystys_id = " . s("paivystys") . ")
     ORDER BY kutsu";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      print ">$option_label\n";
    }
  }
  
  print "</select>\n";
}

# Tehdn ryhmist valintalista. Listaan kelpuutetaan ryhmt, jotka
# kuuluvat valittuun operaatioon tai ovat sellaisia, jotka nkyvt kaikille.
# jos on olemassa annettu ryhm, valitaan se valmiiksi

function select_ryhma_kutsu($kutsu)
{
  global $prefix;
  
  print "<select name=\"ryhma_id\">\n";

  $sql =
    "SELECT id, kutsu
     FROM ryhma
     WHERE alue_id = 2
           OR (alue_id = " . s("alue") . " AND paivystys_id = 2)
           OR (paivystys_id = " . s("paivystys") . ")
     ORDER BY kutsu";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      print "<option value=\"$option_value\"";
      if ($option_label == $kutsu) { print " selected"; }
      print ">$option_label\n";
    }
  }
  
  print "</select>\n";
}

# Tehdn ryhmist valintalista. Listaan kelpuutetaan ryhmt, jotka
# kuuluvat valittuun operaatioon tai id = 1.
# jos on olemassa ryhm "JOHTO", valitaan se valmiiksi mikli mitn
# ryhm ei viel ole valittu.

function select_johto_ryhma($current,$paivystys_id)
{
  print "<select name=\"johto_ryhma_id\">\n";

  $sql =
    "SELECT id, kutsu
     FROM ryhma
     WHERE id = 1
           OR (paivystys_id = $paivystys_id)
     ORDER BY kutsu";
  $result = my_mysql_query($sql);
  if ($result) {
    $selected = false;
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      print "<option value=\"$option_value\"";
      if (($current == 1) && ($option_label == "JOHTO")) {
	print " selected";
	$selected = true;
      }
      if (($current != 1) && ($option_value == $current)) {
	print " selected";
	$selected = true;
      }
      if (! $selected && ($option_value == 1)) {
	# this is supposedly the last one
	print " selected";
	$selected = true;
      }
      print ">$option_label\n";
    }
  }
  
  print "</select>\n";
}

# Tehdn ryhmist valintalista. Listaan kelpuutetaan ryhmt, jotka
# kuuluvat valittuun operaatioon tai id = 1.
# jos on olemassa ryhm "VIESTI", valitaan se valmiiksi mikli mitn
# ryhm ei viel ole valittu.

function select_viesti_ryhma($current,$paivystys_id)
{
  print "<select name=\"viesti_ryhma_id\">\n";

  $sql =
    "SELECT id, kutsu
     FROM ryhma
     WHERE id = 1
           OR (paivystys_id = $paivystys_id)
     ORDER BY kutsu";
  $result = my_mysql_query($sql);
  if ($result) {
    $selected = false;
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      print "<option value=\"$option_value\"";
      if (($current == 1) && ($option_label == "VIESTI")) {
	print " selected";
	$selected = true;
      }
      if (($current != 1) && ($option_value == $current)) {
	print " selected";
	$selected = true;
      }
      if (! $selected && ($option_value == 1)) {
	# this is supposedly the last one
	print " selected";
	$selected = true;
      }
      print ">$option_label\n";
    }
  }
  
  print "</select>\n";
}

# Tehdn ryhmn tilakoodesita valintalista. Listaan kelpuutetaan koodit, jotka
# kuuluvat valittuun operaatioon tai ovat sellaisia, jotka nkyvt kaikille.

function select_ryhma_tila_id($current_value)
{
  global $prefix;
  
  print "<select name=\"ryhma_tila_id\">\n";

  $sql =
    "SELECT id, ryhma_tila
     FROM ryhma_tila
     WHERE alue_id = 2
           OR (alue_id = " . s("alue") . " AND paivystys_id = 2)
           OR (paivystys_id = " . s("paivystys") . ")
     ORDER BY ryhma_tila";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      print ">$option_label\n";
    }
  }
  
  print "</select>\n";
}

# Tehdn sijaintikoodeista valintalista. Listaan kelpuutetaan sijainnit, jotka
# kuuluvat valittuun operaatioon tai ovat sellaisia, jotka nkyvt kaikille.

function select_paikka_id($current_value)
{
  global $prefix;
  
  print "<select name=\"paikka_id\">\n";

  $sql =
    "SELECT id, paikka, alue_id, paivystys_id
     FROM paikka
     WHERE alue_id = 2
           OR (alue_id = " . s("alue") . " AND paivystys_id = 2)
           OR (paivystys_id = " . s("paivystys") . ")
     ORDER BY paikka";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      print ">$option_label\n";
    }
  }
  
  print "</select>\n";
}

# tehdn henkiln tilakoodeista valintalista jossa on valittavan tiedon
# lisksi alue ja operaatio. operaatiot valitaan kyttjn oikeuksien mukaan.

function select_hlo_tila_full($current_value)
{
  global $userid;
  
  print "<select name=\"hlo_tila_id\">\n";

  if (is_superuser($userid))
    $limiter_sql = "";
  else
    $limiter_sql = "
WHERE paivystys_id = 2
      OR alue_id = 2
      OR paivystys_id IN (SELECT paivystys_id
                          FROM kayttajat_paivystys
                          WHERE kayttajat_id = $userid)
      OR alue_id IN  (SELECT alue_id
                      FROM kayttajat_alue
                      WHERE kayttajat_id = $userid)
";

  $sql = "
SELECT id, hlo_tila, alue_id, paivystys_id
FROM hlo_tila
$limiter_sql
ORDER BY alue_id,paivystys_id,hlo_tila
";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      $alue_id = $data[2];
      $paivystys_id = $data[3];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      $paivystys_label = tab_col_id("paivystys","nimi",$paivystys_id);
      $alue_label = tab_col_id("alue","",$alue_id);
      $lisa_label = " [$alue_label, $paivystys_label]";
      print ">$option_label$lisa_label\n";
    }
  }
  
  print "</select>\n";
}

# tehdn henkiln tilakoodeista valintalista. Listaan kelpuutetaan
# kaikkialle nkyvt ja nykyiseen operaatioon tai alueeseen kuuluvat koodit.

function select_hlo_tila($current_value)
{
  global $userid, $prefix;
  
  print "<select name=\"hlo_tila_id\">\n";

  $sql =
    "SELECT id, hlo_tila
     FROM hlo_tila
     WHERE alue_id = 2
           OR (alue_id = " . s("alue") . " AND paivystys_id = 2)
           OR (alue_id = " . s("alue") . "
               AND paivystys_id = " . s("paivystys") . ")
     ORDER BY hlo_tila";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      print ">$option_label\n";
    }
  }
  
  print "</select>\n";
}

# tehdn jrjestist valintalista jossa on valittavan tiedon lisksi alue,
# valitaan kyttjn oikeuksien mukaan.

function select_jarjesto_full($current_value)
{
  global $userid;
  
  print "<select name=\"jarjesto_id\">\n";

  if (is_superuser($userid))
    $limiter_sql = "";
  else
    $limiter_sql =
      "WHERE alue_id = 2
             OR alue_id IN (SELECT alue_id
                            FROM kayttajat_alue
                            WHERE kayttajat_id = $userid)";

  $sql =
    "SELECT id, jarjesto, alue_id
     FROM jarjesto
     $limiter_sql
     ORDER BY alue_id,jarjesto";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      $alue_id = $data[2];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      $alue_label = tab_col_id("alue","",$alue_id);
      $lisa_label = "[$alue_label]";
      print ">$option_label$lisa_label\n";
    }
  }
  
  print "</select>\n";
}

# tehdn jrjestist valintalista normaalikyttn.

function select_jarjesto($current_value)
{
  global $userid, $prefix;
  
  print "<select name=\"jarjesto_id\">\n";

  $sql =
    "SELECT id, jarjesto
     FROM jarjesto
     WHERE alue_id = 2
           OR (alue_id = " . s("alue") . ")
     ORDER BY jarjesto";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      print ">$option_label\n";
    }
  }
  
  print "</select>\n";
}

function tee_valinta_plus_0($variable, $current_value, $table, $id_col,
			    $label_col, $extra_sql, $nolla)
{
  print "<select name=\"$variable\">\n";

  print "<option value=\"0\">$nolla";

  $sql = "SELECT $id_col, $label_col FROM $table $extra_sql";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($data = mysql_fetch_row($result)) {
      $option_value = $data[0];
      $option_label = $data[1];
      print "<option value=\"$option_value\"";
      if ($option_value == $current_value) { print " selected"; }
      print ">$option_label\n";
    }
  }
  
  print "</select>\n";
}

function etsi_teksti($variable, $current_value, $table, $id_col, $label_col)
{
  $ret = '*VIRHE*';
  $result = my_mysql_query("
SELECT $label_col
FROM $table
WHERE $id_col = $current_value
");
  if ($result) {
    $data = mysql_fetch_row($result);
    $ret = $data[0];
  }
  return $ret;
}

function bgcolor_valk()
{
  return " bgcolor=\"white\"";
}

function body_bgcolor()
{
  return "<body vlink=\"maroon\"" . bgcolor_valk() . ">";
}

# taustavri taulukoiden korostettavia rivej varten
function bgcolor_vaalsin()
{
# return '#99daed';
  return ' bgcolor=#bcf3e8';
}

function tr_bgcolor()
{
  return '<tr' . bgcolor_vaalsin() . '>';
}

# tarkastetaan, olemmeko aluevastaava annetulle alueelle tai pkyttj.
# 2 == virhe, 0 == ok

function alue_oikeus($alue_id) {
  global $userlevel_no, $prefix;

  if ($userlevel_no > 25)
    return 0;

  $a_id =
    ota_yksi("SELECT alue_id
              FROM kayttajat_alue
              WHERE kayttajat_id = " . s("userid") . "
                    AND alue_id = $alue_id");
  if ($a_id == $alue_id)
    return 0;

  return 2;
}

# kyttj pkyttj?

function oltava_0($viesti)
{
  global $userlevel_no;
  
  if ($userlevel_no < 25) {
    loki("oltava_0: $viesti");
    exit("
<p>Sinulla ei ole oikeutta kytt tt toiminnetta.
Ota yhteytt yllpitjn.");
  }
}

# kyttj vhintn aluevastaava?

function oltava_aluevastaava($viesti)
{
  global $userlevel_no;
  
  if ($userlevel_no < 15) {
    loki("oltava_aluevastaava: $viesti");
    exit("
<p>Sinulla ei ole oikeutta kytt tt toiminnetta.
Ota yhteytt yllpitjn.");
  }
}

# kyttjll oikeus yli 1 operaatioon?

function oltava_useita($viesti)
{
  global $operations, $userlevel_no;

  if ($userlevel_no > 25)
    return;
  
  if ($operations <= 1) {
    loki("oltava_useita: $viesti");
    exit("
<p>Sinulla ei ole oikeutta kytt tt toiminnetta.
Ota yhteytt yllpitjn.");
  }
}

# do current credentials have permission to view a table item in such
# a table which has both alue_id and paivystys_id?

function oltava_nakyvilla($viesti, $taulu, $id)
{
  debug(1,"entering oltava_nakyvilla: viesti=$viesti, taulu=$taulu, id=$id");
    
  if ($id == 0) {
    return; # special case
  }

  $ret_p = visible_operation_tab($msg, $taulu, $id);
  if ($ret_p == 2) 
    exit("<p>$viesti: $msg\n");
}

# do current credentials have permission to handle a table item in such
# a table which has both alue_id and paivystys_id?

function oltava_sallittu($viesti, $taulu, $id)
{
  debug(1,"entering oltava_sallittu: viesti=$viesti, taulu=$taulu, id=$id");
    
  if ($id == 0) {
    return; # special case
  }

  $ret_p = permission_tab($msg, $taulu, $id);
  if ($ret_p == 2) 
    exit("<p>$viesti: $msg\n");
}

function oltava_sallittu_peri($viesti, $taulu1, $taulu2, $id)
{
  global $sallittu_paivystys;
  
  if ($sallittu_paivystys == 0) {
    return; # root, ok
  }

  if ($id == 0) {
    return; # special case
  }

  $taulu2id = ota_yksi("SELECT $taulu2_id FROM $taulu1 WHERE id = $id");
  $paivystys_id
    = ota_yksi("SELECT paivystys_id FROM $taulu2 WHERE id = $taulu2id");
  if ($paivystys_id == 0) {
    return; # general permission, ok
  }
  if ($paivystys_id == $sallittu_paivystys) {
    return; # express permission, ok
  }
  loki("oltava_sallittu_peri: $viesti taulu1=$taulu1 taulu2=$taulu2 id=$id");
  exit("
<p>Sinulla ei ole oikeutta thn tietueeseen. Ota yhteytt yllpitjn.");
}

# do current credentials match to the area in the item?

function oltava_alueella($viesti, $taulu, $id)
{
  global $userlevel_no;
  
  if ($id == 0) {
    return; # special case
  }

  $alue_id = tab_col_id($taulu,"alue_id",$id);
  if (permission_alue_id($herja, $alue_id) == 2)
    exit("<p>$viesti: Sinulla ei ole oikeutta thn tietueeseen."
	 . " Ota yhteytt yllpitjn.");
}

# sivun loppuun tulevat tekstit

function loppu()
{
  global $sallittu_paivystys, $viha_versio, $username, $userlevel,
    $userlevel_no, $operations, $userid;
  
  $now = date('Y-m-d H:i:s');
  echo "<p><small>ViHa V$viha_versio, kyttj $username($userid)",
    ", kyttjtaso $userlevel($userlevel_no)",
    ", sallittuja operaatioita $operations",
    ", valittu operaatio " . ota_paivystys_nimi(),
    ", IP $_SERVER[REMOTE_ADDR], $now</small>\n";
}

function tab_col_id($tab,$col,$id,$log=true) {
  if ($col == '') { $col = $tab; }
  return ota_yksi("SELECT $col FROM $tab WHERE id = $id",$log);
}

function tab_col_id_none($tab,$col,$id) {
  if ($col == '') { $col = $tab; }
  return ota_yksi_0("SELECT $col FROM $tab WHERE id = $id",
		    $id, "EI MIKN");
}

function tab_col_id_x_not($tab,$col,$id,$x) {
  if ($id == $x)
    return "EI OLE";

  if ($col == '') { $col = $tab; }
  
  return ota_yksi("SELECT $col FROM $tab WHERE id = $id", $id);
}

function tab_col_id_nobody($tab,$col,$id) {
  if ($col == '') { $col = $tab; }
  return ota_yksi_0("SELECT $col FROM $tab WHERE id = $id",
		    $id, "EI KUKAAN");
}

function tab_col_id_all($tab,$col,$id) {
  if ($col == '') { $col = $tab; }
  return ota_yksi_0("SELECT $col FROM $tab WHERE id = $id",
		    $id, "KAIKKI");
}

function tab_col_id_personal($tab,$col,$id) {
  if ($col == '') { $col = $tab; }
  return ota_yksi_0("SELECT $col FROM $tab WHERE id = $id",
		    $id, "HENKILKOHTAINEN");
}

function authenticated($username, $password) {
  global $userid;
  
  if (!isset($username) || !isset($password))
    return false;

  if ($username === '' || $password === '')
    return false;

  $pass_db =
    ota_yksi("SELECT password FROM kayttajat WHERE username = '$username'");
  $pass_user = crypt($password, $pass_db);

  if ($pass_db === '' || $pass_user === '') {
    loki("Kyttjnimell $username on jompikumpi salasanatiiviste tyhj"
	 . " pass_db=$pass_db, pass_user=$pass_user");
    return false;
  }
  
  $userid = ota_yksi("SELECT id FROM kayttajat WHERE username='$username'");
  if ($userid == 0) {
    loki("Kyttjnimelle $username ei ole id:t ($userid == 0)");
    return false;
  }

  if ($pass_db === $pass_user)
    return true;

  return false;
}

function is_superuser($userid) {
  if (tab_col_id("kayttajat","root",$userid) == 1)
    return true;
  else
    return false;
}

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# checks the given items against current credentials. this is called
# from a client with data items taken from object which user wishes
# to modify.
# also checks general legality of alue_id and paivystys_id.
# if $log, the final result of the permission check will be logged.

function permission_tab(&$msg, $tab, $id, $log = true) {
  debug(1,"entering permission_tab: msg=$msg, tab=$tab, id=$id, log=$log");
  return permission_ids($msg, tab_col_id($tab,"alue_id",$id),
			tab_col_id($tab,"paivystys_id",$id), $log);
}

function permission_ids(&$msg, $alue_id, $paivystys_id, $log = true) {
  global $userlevel_no, $config_debug, $prefix;
  
  debug(1,"entering permission_ids: msg=$msg, alue_id=$alue_id, "
	. "paivystys_id=$paivystys_id, log=$log");

  if (($config_debug >=1) && ($alue_id == '')) {
    echo "<p>";
    debug_print_backtrace();
  }

  if (tab_col_id("alue","",$alue_id) == '') {
    $msg = "Aluetta $alue_id ei lydy.";
    return 2;
  }

  $paivystys_alue_id = tab_col_id("paivystys","alue_id",$paivystys_id);
  if ($paivystys_alue_id  == '') {
    $msg = "Operaatiota $paivystys_id ei lydy.";
    return 2;
  }

  if (($paivystys_alue_id > 2) && ($paivystys_id > 2)
      && ($alue_id != $paivystys_alue_id)) {
	$msg = "Alue ($alue_id) ja operaation alue ($paivystys_alue_id)"
	  . " eivt sovi yhteen.";
	return 2;
  }

  # varsinainen oikeustarkastus.
  # pkyttj?
  if ($userlevel_no > 25)
    return 0;

  # pikakaista.
  if (s('paivystys') == $paivystys_id)
    return 0;

  # mahdollisuus kaapata ei-missaan oleva objekti omalla alueella.
  if (($paivystys_id == 1) && (s('alue') == $alue_id))
    return 0;

  # oikeus thn operaatioon?
  if (ota_yksi("SELECT COUNT(*)
                FROM kayttajat_paivystys
                WHERE paivystys_id = $paivystys_id
                      AND kayttajat_id = " . s("userid")) != 0)
    return 0;

  # aluevastaava?
  if (ota_yksi("SELECT COUNT(*)
                FROM kayttajat_alue
                WHERE alue_id = $paivystys_alue_id
                      AND kayttajat_id = " . s("userid")) != 0)
    return 0;

  # jos thn asti pstn niin oikeutta ei sitten ole.
  if ($log)
    loki("permission_ids: no permission, alue_id=$alue_id,"
	 . " paivystys_id=$paivystys_id,"
	 . " userid=" . s("userid") . ","
	 . " paivystys=" . s("paivystys") . ","
	 . " userlevel_no=$userlevel_no");
  $msg = "Sinulla ei ole oikeutta thn tietueeseen.";
  return 2;

}

# checks if the given item should be visible on operation-based
# (e.g. basic) display. 
# also checks general legality of alue_id and paivystys_id.
# if $log, the final result of the permission check will be logged.

function visible_operation_tab(&$msg, $tab, $id, $log = true) {
  return visible_operation_ids($msg, tab_col_id($tab,"alue_id",$id),
			       tab_col_id($tab,"paivystys_id",$id), $log);
}

function visible_operation_ids(&$msg, $alue_id, $paivystys_id, $log = true) {
  global $userlevel_no, $prefix;
  
  if (tab_col_id("alue","",$alue_id) == '') {
    $msg = "Aluetta $alue_id ei lydy.";
    return 2;
  }

  $paivystys_alue_id = tab_col_id("paivystys","alue_id",$paivystys_id);
  if ($paivystys_alue_id  == '') {
    $msg = "Operaatiota $paivystys_id ei lydy.";
    return 2;
  }

  if (($paivystys_alue_id > 2) && ($paivystys_id > 2)
      && ($alue_id != $paivystys_alue_id)) {
	$msg = "Alue ($alue_id) ja operaation alue ($paivystys_alue_id)"
	  . " eivt sovi yhteen.";
	return 2;
  }

  # varsinainen tarkastus.
  
  if ($alue_id == 2)
    return 0;

  if ((s('alue') == $alue_id) && ($paivystys_id == 2))
    return 0;

  if (s('paivystys') == $paivystys_id)
    return 0;

  # jos thn asti pstn niin oikeutta ei sitten ole.
  if ($log)
    loki("visible_operation_ids: no permission, alue_id=$alue_id,"
	 . " paivystys_id=$paivystys_id,"
	 . " userid=" . s("userid") . ","
	 . " paivystys=" . s("paivystys") . ","
	 . " userlevel_no=$userlevel_no");
  $msg = "Sinulla ei ole oikeutta thn tietueeseen.";
  return 2;

}

# used in admin "hallinnolliset" displays. shows also objects on our area
# w/ operation code 1 (NONE). otherwise works as ...operation...
# also checks general legality of alue_id and paivystys_id.
# if $log, the final result of the permission check will be logged.

function visible_admin_tab(&$msg, $tab, $id, $log = true) {
  return visible_admin_ids($msg, tab_col_id($tab,"alue_id",$id),
			   tab_col_id($tab,"paivystys_id",$id), $log);
}

function visible_admin_ids(&$msg, $alue_id, $paivystys_id, $log = true) {
  global $userlevel_no, $prefix;
  
  if (tab_col_id("alue","",$alue_id) == '') {
    $msg = "Aluetta $alue_id ei lydy.";
    return 2;
  }

  $paivystys_alue_id = tab_col_id("paivystys","alue_id",$paivystys_id);
  if ($paivystys_alue_id  == '') {
    $msg = "Operaatiota $paivystys_id ei lydy.";
    return 2;
  }

  if (($paivystys_alue_id > 2) && ($paivystys_id > 2)
      && ($alue_id != $paivystys_alue_id)) {
	$msg = "Alue ($alue_id) ja operaation alue ($paivystys_alue_id)"
	  . " eivt sovi yhteen.";
	return 2;
  }

  # varsinainen tarkastus.
  
  if ($alue_id == 2)
    return 0;

  if ((s('alue') == $alue_id) && ($paivystys_id <= 2))
    return 0;

  if (s('paivystys') == $paivystys_id)
    return 0;

  # oikeus thn operaatioon?
  if (ota_yksi("SELECT COUNT(*)
                FROM kayttajat_paivystys
                WHERE paivystys_id = $paivystys_id
                      AND kayttajat_id = " . s("userid")) != 0)
    return 0;

  # aluevastaava?
  if (ota_yksi("SELECT COUNT(*)
                FROM kayttajat_alue
                WHERE alue_id = $paivystys_alue_id
                      AND kayttajat_id = " . s("userid")) != 0)
    return 0;

  # jos thn asti pstn niin oikeutta ei sitten ole.
  if ($log)
    loki("visible_admin_ids: no permission, alue_id=$alue_id,"
	 . " paivystys_id=$paivystys_id,"
	 . " userid=" . s("userid") . ","
	 . " paivystys=" . s("paivystys") . ","
	 . " userlevel_no=$userlevel_no");
  $msg = "Sinulla ei ole oikeutta thn tietueeseen.";
  return 2;

}

# do current credentials match to the area in the item?

function permission_alue_id(&$msg, $alue_id, $log = true) {
  global $userlevel_no, $prefix;
  
  if (tab_col_id("alue","",$alue_id) == '') {
    $msg = "Aluetta $alue_id ei lydy.";
    return 2;
  }

  # varsinainen oikeustarkastus.
  # pkyttj?
  if ($userlevel_no > 25)
    return 0;

  # kaikilla alueilla? samalla alueella kuin kyttj?
  if ($alue_id == 2 || $alue_id == s('alue'))
    return 0;

  # jos thn asti pstn niin oikeutta ei sitten ole.
  if ($log)
    loki("permission_alue_id: no permission, alue_id=$alue_id,"
	 . " userid=" . s("userid") . ","
	 . " alues=" . s("alue") . ","
	 . " userlevel_no=$userlevel_no");
  $msg = "Sinulla ei ole oikeutta thn tietueeseen.";
  return 2;

}

# this is for -takt and -oper displays. display item if area code
# is all areas or current one.
# nkyyk annettu alue listauksessa?

function alue_nakyy($alue_id) {
  global $prefix;
  
  if ($alue_id == 2 || $alue_id == s('alue'))
    return true;

  return false;
}

# format and colour an error or warning message. If code == 0, no output.

function p_herja($code,$msg) {
  switch ($code) {
  case 1:
    echo "<p><font color=\"blue\">$msg</font>\n";
    break;
  case 2:
    echo "<p><font color=\"red\">$msg</font>\n";
    break;
  }
}

# add time record for a person. only add a record if needed.
# one of the following is called each time hlo.hlo_tila_id is changed.
# E.g. no need to have two or more "In" records immediately after each other
# if other parameters match.
# also record other changes.

# w/ hlo.id

function add_hlo_ajat($hlo_id) {

  $now = date('Y-m-d H:i:s');
  
  # In/Out
  $in =
    ota_yksi("SELECT paikalla
              FROM hlo_tila
              WHERE id = (SELECT hlo_tila_id
                          FROM hlo
                          WHERE id = $hlo_id)");

  if ($in)
    $new = 1; # tuli
  else
    $new = 2; # lhti
  
  $a = tab_col_id("hlo","alue_id",$hlo_id);
  $p = tab_col_id("hlo","paivystys_id",$hlo_id);
  $r = tab_col_id("hlo","ryhma_id",$hlo_id);
  $s = tab_col_id("hlo","hlo_asema_id",$hlo_id);
  $last =
    ota_yksi("SELECT hlo_ajat_tyyppi_id
              FROM hlo_ajat
              WHERE variable_id = $p AND hlo_id = $hlo_id
                    AND hlo_ajat_tyyppi_id < 3
              ORDER BY ts DESC
              LIMIT 1");
  # listn vain mikli tila muuttuu
  if ($new != $last) {
    $sql =
      "INSERT INTO hlo_ajat
       SET hlo_id = $hlo_id,
           hlo_ajat_tyyppi_id = $new,
           variable_id = $p,
           ts = '$now'";
    my_mysql_query($sql,true,true);
  }

  # Area
  $last =
    ota_yksi("SELECT variable_id
              FROM hlo_ajat
              WHERE hlo_ajat_tyyppi_id = 3 AND hlo_id = $hlo_id
              ORDER BY ts DESC
              LIMIT 1");
  # listn vain mikli muuttuu
  if ($a != $last) {
    $sql =
      "INSERT INTO hlo_ajat
       SET variable_id = $a,
           hlo_id = $hlo_id,
           hlo_ajat_tyyppi_id = 3,
           ts = '$now'";
    my_mysql_query($sql,true,true);
  }
  
  # Operation
  $last =
    ota_yksi("SELECT variable_id
              FROM hlo_ajat
              WHERE hlo_ajat_tyyppi_id = 4 AND hlo_id = $hlo_id
              ORDER BY ts DESC
              LIMIT 1");
  # listn vain mikli muuttuu
  if ($p != $last) {
    $sql =
      "INSERT INTO hlo_ajat
       SET variable_id = $p,
           hlo_id = $hlo_id,
           hlo_ajat_tyyppi_id = 4,
           ts = '$now'";
    my_mysql_query($sql,true,true);
  }
  
  # Squad
  $last =
    ota_yksi("SELECT variable_id
              FROM hlo_ajat
              WHERE hlo_ajat_tyyppi_id = 5 AND hlo_id = $hlo_id
              ORDER BY ts DESC
              LIMIT 1");
  # listn vain mikli muuttuu
  if ($r != $last) {
    $sql =
      "INSERT INTO hlo_ajat
       SET hlo_id = $hlo_id,
           hlo_ajat_tyyppi_id = 5,
           variable_id = $r,
           ts = '$now'";
    my_mysql_query($sql,true,true);
  }
  
  # Position
  $last =
    ota_yksi("SELECT variable_id
              FROM hlo_ajat
              WHERE hlo_ajat_tyyppi_id = 6 AND hlo_id = $hlo_id
              ORDER BY ts DESC
              LIMIT 1");
  # listn vain mikli muuttuu
  if ($s != $last) {
    $sql =
      "INSERT INTO hlo_ajat
       SET hlo_id = $hlo_id,
           hlo_ajat_tyyppi_id = 6,
           variable_id = $s,
           ts = '$now'";
    my_mysql_query($sql,true,true);
  }
  
} # add_hlo_ajat

# w/ SQL WHERE clause

function add_hlo_ajat_sql($where) {

  # iterate thru all possible hlo.id:s and call the master function for each.
  $sql = "SELECT id FROM hlo $where";
  $result = my_mysql_query($sql);
  if ($result) {
    while ($a = mysql_fetch_array($result)) {
      add_hlo_ajat($a['id']);
    } # while
  } # if result
  
} # add_hlo_ajat_sql

# return given session parameter. we use prefixes to distinct different
# installations within the same machine.

function s($var) {
  global $prefix;
  
  return $_SESSION[$prefix . $var];
}


# ----------------------------------------------------------------------------
# General startup code begins here.
# ----------------------------------------------------------------------------

session_start();

error_reporting(E_ERROR | E_WARNING | E_PARSE |
		E_CORE_ERROR | E_CORE_WARNING |
		E_COMPILE_ERROR | E_COMPILE_WARNING |
		E_USER_ERROR | E_USER_WARNING);

# defaults for the config parameters. 
# note that the following code is duplicated on logoff.php and in a sense
# config-sample.php .

$config_mysql_server = "127.0.0.1:3306";
$config_mysql_user = "tu";
$config_mysql_pass = "tilanne";
$config_db = "tilanne3";
$config_realm = "ViHa";
$config_main_title = "Psivu";
$config_main_h1 = "Viestin hallintajrjestelm ViHa";
$config_main_motd = "";
$config_debug = "";
$config_prefix = 'viha_';

# if there is a config file, read it.
 
if (is_readable("config.php")) {
  include "config.php";
 }
$prefix = $config_prefix;

if ($debug > 0)
  openlog  ("ViHa", 0, LOG_USER);

$viha_versio = '5.15';
$viha_pvm = '2009-06-13';

# we accept only those databases which have one of the versions below.
$hyvaksyttavat_kanta_versiot = array(1 => "5.10");

$username = clean_user($_SERVER['PHP_AUTH_USER']);
$password = clean_txt($_SERVER['PHP_AUTH_PW']);
$userid = 0;

header('Content-Type: text/html; charset=iso-8859-1');

mysql_pconnect($config_mysql_server,$config_mysql_user,$config_mysql_pass);
mysql_select_db($config_db);

$kanta_versio = tab_col_id("versio","",1,false);
$tulos = array_search($kanta_versio, $hyvaksyttavat_kanta_versiot);
if ($tulos == 0) {
  die("<p>Tietokannan versio ($kanta_versio) ei sovi thn "
      . "ohjelmistoversioon.\n");
 }

if (s('logoff') || !authenticated($username, $password)) {
  # challenge user.
  if (s('logoff')) {
    loki("Kyttj $username kirjautui ulos. IP=$_SERVER[REMOTE_ADDR]");
  }
  unset($_SESSION[$prefix . 'authenticated']);
  unset($_SESSION[$prefix . 'userid']);
  unset($_SESSION[$prefix . 'paivystys']);
  unset($_SESSION[$prefix . 'alue']);
  unset($_SESSION[$prefix . 'logoff']);
  header("WWW-Authenticate: Basic Realm=\"$config_realm\"");
  header('HTTP/1.0 401 Unauthorized');

  # if we get here, user has canceled the dialog. 
  echo "
<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//FI\">
<html><head>
  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">
  <title>ViHa Kyttoikeustarkastus eponnistui</title>
</head>
<body>
<p>Kyttoikeustarkastus eponnistui. Ota yhteys yllpitjn.
";
  exit;
 }

echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//FI\">\n";
$_SESSION[$prefix . 'authenticated'] = true;

$wanha_session_userid = s('userid');

# lasketaan operaatiot johon kyttjll on oikeus.
# tarkastetaan kyttjtaso.
# asetetaan valituksi id-numeroltaan suurin.
$operations = 0;
$userlevel = 'peruskyttj';
$userlevel_no = 10;
$valittu = 1;
if (tab_col_id("kayttajat","root",$userid) == 1) {
  # oikeus kaikkiin
  $operations = ota_yksi("SELECT COUNT(*) FROM paivystys") - 2;
  $userlevel = 'pkyttj';
  $userlevel_no = 30;
  $valittu = ota_yksi("SELECT MAX(id) FROM paivystys");
 } else {
  # onko aluevastaava?
  $vastuualueet =
    ota_yksi("SELECT COUNT(*)
              FROM kayttajat_alue
              WHERE kayttajat_id = $userid");
  # lasketaan erikseen alueet ja muut
  if ($vastuualueet > 0) {
    $userlevel = "aluevastaava";
    $userlevel_no = 20;
    $alueet =
      ota_yksi("SELECT COUNT(*)
                FROM paivystys
                WHERE alue_id IN (SELECT alue_id
                                  FROM kayttajat_alue
                                  WHERE kayttajat_id = $userid)");
    $operations += $alueet;
  }
  $muut =
    ota_yksi("SELECT COUNT(*)
              FROM paivystys
              WHERE id IN (SELECT paivystys_id
                           FROM kayttajat_paivystys
                           WHERE kayttajat_id = $userid)
                    AND alue_id NOT IN (SELECT alue_id
                                        FROM kayttajat_alue
                                        WHERE kayttajat_id = $userid)");
  $operations += $muut;
  $valittu =
    ota_yksi("SELECT MAX(id)
              FROM paivystys
              WHERE id IN (SELECT paivystys_id
                           FROM kayttajat_paivystys
                           WHERE kayttajat_id = $userid)
                    OR alue_id IN (SELECT alue_id
                                   FROM kayttajat_alue
                                   WHERE kayttajat_id = $userid)");
 }

# Asetetaan valituksi operaatioksi id-numeroltaan suurin.
$_SESSION[$prefix . 'userid'] = $userid;
if (s('paivystys') == '')
  $_SESSION[$prefix . 'paivystys'] = $valittu;
if (s('alue') == '')
  $_SESSION[$prefix . 'alue'] = tab_col_id("paivystys","alue_id",$valittu);

# tarkistetaan ett operaatio ja alue ovat olemassa. jos eivt, jotain on
# vialla ja stop.

if (tab_col_id("paivystys","nimi",s('paivystys')) == '') {
  die("<p>Operaatiota " . s("paivystys") . " ei lydy!?"
      . " <li><a href=\"logoff.php\">Kirjaudu ulos ja yrit uudelleen</a>");
 }
if (tab_col_id("alue","",s('alue')) == '') {
  die("<p>Aluetta " . s("alue") . " ei lydy!?"
      . " <li><a href=\"logoff.php\">Kirjaudu ulos ja yrit uudelleen</a>");
 }

if ($userid != $wanha_session_userid)
  loki("Kyttj $username kirjautui jrjestelmn. IP=$_SERVER[REMOTE_ADDR]");

?>

<!-- RCS $Id: common.php,v 1.206 2009/06/13 08:24:08 riku Exp $ -->
