<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# hlo_ajat tarkastusfunktiot

function hlo_ajat_ok(&$msg,$id,$alue_id,$paivystys_id,$hlo_id,
		     $hlo_ajat_tyyppi_id,$ryhma_id,$hlo_asema_id,$ts) {
  global $table;
  
  $msg = '';
  $ret = 0;

  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }
  
  # XXX kayttooikeustarkastus puuttuu!
   
  # tarpeelliset kentt
  if ($hlo_id == 0 || $hlo_ajat_tyyppi_id == 0) {
    $msg = "Henkil ja tyyppi ovat pakollisia tietoja";
    $msg .= $tail;
    return 2;
  }

  if (tab_col_id("alue","",$alue_id) == '') {
    $msg = "Aluetta $alue_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("paivystys","nimi",$paivystys_id) == '') {
    $msg = "Operaatiota $paivystys_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("hlo","nimi",$hlo_id) == '') {
    $msg = "Henkil $hlo_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("hlo_ajat_tyyppi","",$hlo_ajat_tyyppi_id) == '') {
    $msg = "Tyyppi $hlo_ajat_tyyppi_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("ryhma","kutsu",$ryhma_id) == '') {
    $msg = "Ryhm $ryhma_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("hlo_asema","",$hlo_asema_id) == '') {
    $msg = "Asemakoodia $hlo_asema_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (timestamp_ok($ts) == 2) {
    $msg = "Aikaleima $ts ei kelpaa.";
    $msg .= $tail;
    return 2;
  }
  
  # duplikaatit
  # ei tarkasteta

  return $ret;
}

function hlo_ajat_add_ok(&$msg,$alue_id,$paivystys_id,$hlo_id,
			 $hlo_ajat_tyyppi_id,$ryhma_id,$hlo_asema_id,$ts) {
  return hlo_ajat_ok($msg,'',$alue_id,$paivystys_id,$hlo_id,
		     $hlo_ajat_tyyppi_id,$ryhma_id,$hlo_asema_id,$ts);
}

function hlo_ajat_save_ok(&$msg,$id,$alue_id,$paivystys_id,$hlo_id,
			  $hlo_ajat_tyyppi_id,$ryhma_id,$hlo_asema_id,$ts) {
  return hlo_ajat_ok($msg,$id,$alue_id,$paivystys_id,$hlo_id,
		     $hlo_ajat_tyyppi_id,$ryhma_id,$hlo_asema_id,$ts);
}

function hlo_ajat_remove_ok(&$msg,$id,$log = true) {
  global $table;
  
  $ret = 0;

  # XXX kayttooikeustarkastus puuttuu!
  
  return $ret;
}

?>

<!-- RCS $Id: hlo_ajat-ok.php,v 1.6 2009/06/06 16:15:51 riku Exp $ -->
