<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

$table = "hlo_ajat";
$file = basename(__FILE__);

include "common.php";
include "hlo_ajat-ok.php";

function assign_variable_id($hlo_ajat_tyyppi_id,$alue_id,$paivystys_id,
			    $ryhma_id,$hlo_asema_id) {
  $ret = 0;
  switch ($hlo_ajat_tyyppi_id) {
  case 1:
  case 2:
  case 4:
    $ret = $paivystys_id;
    break;
  case 3:
    $ret = $alue_id;
    break;
  case 5:
    $ret = $ryhma_id;
    break;
  case 6:
    $ret = $hlo_asema_id;
    break;
  }
  return $ret;
}

function translate_variable_id($hlo_ajat_tyyppi_id,$variable_id) {
  $ret = 'VIRHE';
  switch ($hlo_ajat_tyyppi_id) {
  case 1:
  case 2:
  case 4:
    $ret = tab_col_id("paivystys","nimi",$variable_id);
    break;
  case 3:
    $ret = tab_col_id("alue","",$variable_id);
    break;
  case 5:
    $ret = tab_col_id("ryhma","kutsu",$variable_id);
    break;
  case 6:
    $ret = tab_col_id("hlo_asema","",$variable_id);
    break;
  }
  return $ret;
}

echo "
<html>
<head>
 <title>ViHa - Tyajat</title>
</head>
" . body_bgcolor() . "
<h1>Tyaikojen ksittely ja siirrot</h1>
";

hallinnolliset_linkit();

$id = get_nro_0('id');
$hlo_id = get_nro_0('hlo_id');
$hlo_ajat_tyyppi_id = get_nro_1('hlo_ajat_tyyppi_id');
$alue_id = get_nro_1('alue_id');
$paivystys_id = get_nro_1('paivystys_id');
$ryhma_id = get_nro_1('ryhma_id');
$hlo_asema_id = get_nro('hlo_asema_id');
if ($hlo_asema_id == '')
  $hlo_asema_id = 5;
$ts = get_txt('ts');
$ts = maaginen_kello($ts);

$add = get_txt('add');
$clear = get_txt('clear');
$save = get_txt('save');
$confirm = get_txt('confirm');
$change = get_txt('change');
$remove = get_txt('remove');

oltava_0($file);

if (($add != '') && saa_tehda("$file:add")) {
  $ret = hlo_ajat_add_ok($herja,$alue_id,$paivystys_id,$hlo_id,
			 $hlo_ajat_tyyppi_id,$ryhma_id,$hlo_asema_id,$ts);
  if ($ret != 2) {
    $variable_id
      = assign_variable_id($hlo_ajat_tyyppi_id,$alue_id,$paivystys_id,
			   $ryhma_id,$hlo_asema_id);
    $sql =
      "INSERT INTO hlo_ajat
       SET hlo_id = $hlo_id,
           hlo_ajat_tyyppi_id = $hlo_ajat_tyyppi_id,
           variable_id = $variable_id,
           ts = '$ts'";
    $result = my_mysql_query ($sql);
    loki("$sql id=" . last_insert_id());
    echo "<p>Tiedot listty.\n";
    $clear = "ADD";
  }
  p_herja($ret,$herja);
 } # add

if (($save != '') && saa_tehda("$file:save")) {
  $ret = hlo_ajat_save_ok($herja,$id,$alue_id,$paivystys_id,$hlo_id,
			 $hlo_ajat_tyyppi_id,$ryhma_id,$hlo_asema_id,$ts);
  $clear = "SAVE";
  if ($ret != 2) {
    $variable_id
      = assign_variable_id($hlo_ajat_tyyppi_id,$alue_id,$paivystys_id,
			   $ryhma_id,$hlo_asema_id);
    $sql =
      "UPDATE $table
       SET hlo_id = $hlo_id,
           hlo_ajat_tyyppi_id = $hlo_ajat_tyyppi_id,
           variable_id = $variable_id,
           ts = '$ts'
       WHERE id=$id";
    $result = my_mysql_query ($sql,true,true);
    echo "<p>Tiedot pivitetty.\n";
  }
  p_herja($ret,$herja);
 } # save

if (($confirm != '') && saa_tehda("$file:confirm")) {
  $ret = hlo_ajat_remove_ok($herja,$id);
  if ($ret != 2) {
    $sql = "DELETE FROM $table WHERE id = $id";
    $result = my_mysql_query ($sql,true,true);
    echo "<p>Tiedot poistettu.\n";
    $clear = "SISINEN";
  }
  p_herja($ret,$herja);
 } # confirm

if ($clear != '') {
  $id = '0';
  $alue_id = '1';
  $paivystys_id = '1';
  $hlo_id = '0';
  $hlo_ajat_tyyppi_id = '1';
  $ryhma_id = '1';
  $hlo_asema_id = '5';
  $ts = '';
 }

# readonly tells if the fields are readonly. if not, they are editable.
if ($remove != '') { $readonly = 1; } else { $readonly = 0; }

# removable tells if we can actually remove this record
if ($remove != '') {
  $removable = 0;
  $ret = hlo_ajat_remove_ok($herja,$id,false);
  if ($ret != 2) {
    $removable = 1;
  }
  p_herja($ret,$herja);
 }

echo "<form action=\"\" method=\"GET\">\n";
echo "<p><table border=0>\n";

if ($id != "0") {
  $result = 
    my_mysql_query("SELECT *
                    FROM $table
                    WHERE id = $id");
  $a = mysql_fetch_array($result);
  $hlo_id = $a['hlo_id'];
  $hlo_ajat_tyyppi_id = $a['hlo_ajat_tyyppi_id'];
  $ts = $a['ts'];
  $variable_id = $a['variable_id'];
  switch ($hlo_ajat_tyyppi_id) {
  case 1:
  case 2:
  case 4:
    $paivystys_id = $variable_id;
    break;
  case 3:
    $alue_id = $variable_id;
    break;
  case 5:
    $ryhma_id = $variable_id;
    break;
  case 6:
    $hlo_asema_id = $variable_id;
    break;
  }
}

echo "<tr><td>Id:";
if ($id == "0") {
  echo "<td>(tehdn uusi)\n";
} else {
  echo "<td>$id\n";
}
echo "<td><input type=\"hidden\" name=\"id\" size=8 maxlength=8";
echo " value=\"$id\">\n";

echo "<tr><td>Tyyppi:";
if ($readonly) {
  echo "<td>" . tab_col_id("hlo_ajat_tyyppi","",$hlo_ajat_tyyppi_id) . "\n";
} else {
  echo "<td>\n";
  tee_valinta("hlo_ajat_tyyppi_id", $hlo_ajat_tyyppi_id, "hlo_ajat_tyyppi",
	      "id", "hlo_ajat_tyyppi", "ORDER BY hlo_ajat_tyyppi");
}

echo "<tr><td>Aika:";
if ($readonly) {
  echo "<td>$ts\n";
} else {
  echo "<td><input type=\"text\" name=\"ts\" size=19 maxlength=19";
  echo " value=\"$ts\">\n";
}

echo "<tr><td>Henkil:";
if ($readonly) {
  echo "<td>"
  . ota_yksi_0("SELECT nimi FROM hlo WHERE id = $hlo_id",
	       $hlo_id, "EI KUKAAN")
  . "\n";
} else {
  echo "<td>\n";
  tee_valinta_plus_0("hlo_id", $hlo_id, "hlo", "id",
		     "nimi", "ORDER BY nimi", "EI KUKAAN");
}

echo "<tr><td>Alue:";
if ($readonly) {
  echo "<td>"
    . tab_col_id("alue","",$alue_id)
    . "\n";
} else {
  echo "<td>\n";
  tee_valinta("alue_id", $alue_id, "alue", "id", "alue", "ORDER BY alue");
}

echo "<tr><td>Operaatio:";
if ($readonly) {
  echo "<td>"
    . tab_col_id("paivystys","nimi",$paivystys_id)
    . "\n";
} else {
  echo "<td>\n";
  tee_valinta("paivystys_id", $paivystys_id, "paivystys", "id", "nimi",
	      "ORDER BY nimi");
}

echo "<tr><td>Ryhm:";
if ($readonly) {
  echo "<td>"
    . ota_yksi("SELECT kutsu FROM ryhma WHERE id = $ryhma_id") . "\n";
 } else {
  echo "<td>\n";
  select_ryhma_full($ryhma_id);
 }

echo "<tr><td>Asema:";
if ($readonly) {
  echo "<td>"
    . ota_yksi("SELECT hlo_asema FROM hlo_asema WHERE id = $hlo_asema_id")
    . "\n";
} else {
  echo "<td>\n";
  tee_valinta("hlo_asema_id", $hlo_asema_id, "hlo_asema", "id", "hlo_asema",
	      "ORDER BY pri");
}

echo "</table>\n";

if ($change != "") {
  echo "<input type=\"submit\" name=\"save\" value=\"TALLENNA\">\n";
  echo "<input type=\"submit\" name=\"clear\" value=\"PERUUTA\">\n";
} elseif ($remove != "") {
  if ($removable) {
    echo
      "<input type=\"submit\" name=\"confirm\" value=\"VAHVISTA POISTO\">\n";
  }
  echo "<input type=\"submit\" name=\"clear\" value=\"PERUUTA\">\n";
} else {
  echo "<input type=\"submit\" name=\"add\" value=\"LIS\">\n";
  echo "<input type=\"submit\" name=\"clear\" value=\"TYHJENN\">\n";
}

$sql =
  "SELECT id, ts, hlo_id, hlo_ajat_tyyppi_id, variable_id
   FROM $table
   ORDER BY ts";
$result = my_mysql_query($sql);
if ($result) {
  echo "<p><TABLE BORDER=1>\n";
  echo tr_bgcolor()
    . "<TH>Id<TH>Tyyppi<TH>Aikaleima<TH>Henkil"
    . "<TH>Vaihtuva\n";
  while ($a = mysql_fetch_array($result)) {
    # just skip those items we do not have permission to
#    if (permission_tab($herja,$table,$a['id'],false) == 2)
#      continue; 
    echo "<TR><TD>$a[id]",
      "<TD>" . tab_col_id("hlo_ajat_tyyppi","",$a['hlo_ajat_tyyppi_id']),
      "<TD>$a[ts]",
      "<TD>" . tab_col_id_nobody("hlo","nimi",$a['hlo_id']),
      "<TD>" . translate_variable_id($a['hlo_ajat_tyyppi_id'],
				     $a['variable_id']);
    if ($id == "0") {
      echo "<td><a href=\"$file?id=$a[id]&change=MUUTA\">MUUTA</a>\n";
      echo "<td><a href=\"$file?id=$a[id]&remove=POISTA\">POISTA</a>\n";
    }
  }
  echo "</TABLE>";
} else {
  echo "<p>Plop. Ei tyaikatietoja.";
}

echo "</form>\n";

loppu();

?>
</body> 
</html>
<!-- RCS $Id: hlo_ajat0.php,v 1.9 2009/06/06 16:18:58 riku Exp $ -->
