<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# hlo_asema tarkastusfunktiot

function hlo_asema_ok(&$msg,$id,$hlo_asema,$pri) {
  global $table;
  
  $msg = '';
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # kovakoodatut kentt
  if ($id == "5") {
    $msg = "Koodi numero 5 on suojattu.";
    $msg .= $tail;
    return 2;
  }

  # tarpeelliset kentt
  if ($hlo_asema == '') {
    $msg = 'Asemakoodi on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # tarpeelliset kentt
  if ($pri == '') {
    $msg = 'Prioriteetti on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # suojaus
  if ($modify) {
    if (tab_col_id("hlo_asema","suojattu",$id) == 1) {
      $msg = "Tm tietue on suojattu.";
      $msg .= $tail;
      return 2;
    }
  }

  # duplikaatit
  $dup = ota_yksi("
SELECT id
FROM $table
WHERE hlo_asema = '$hlo_asema'
      $id_sql
");
  if ($dup != '') {
    $msg = "Tllainen koodi on jo olemassa (id=$dup)";
    $msg .= $tail;
    return 2;
  } 

  return 0;
}

function hlo_asema_add_ok(&$msg,$hlo_asema,$pri) {
  return hlo_asema_ok($msg,'',$hlo_asema,$pri);
}

function hlo_asema_save_ok(&$msg,$id,$hlo_asema,$pri) {
  return hlo_asema_ok($msg,$id,$hlo_asema,$pri);
}

function hlo_asema_remove_ok(&$msg,$id) {
  $msg = '';

  # kovakoodatut kentt
  if ($id == "5") {
    $msg = "Koodi numero 5 on suojattu eik sit voi poistaa.";
    return 2;
  }

  # suojattua ei voi poistaa
  if (tab_col_id("hlo_asema","suojattu",$id) == 1) {
    $msg = "Tm tietue on suojattu. Ei voi poistaa.";
    return 2;
  }

  # jos hlo_asemaan on viittauksia henkiliss
  # sit ei voi poistaa
  $ref = ota_yksi("
SELECT COUNT(*)
FROM hlo
WHERE hlo_asema_id = $id
");
  if ($ref != 0) {
    $msg = "Thn koodiin on viittauksia $ref eri henkilss. Sit ei voi
 poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }
  
  return 0;
}

?>

<!-- RCS $Id: hlo_asema-ok.php,v 1.3 2009/02/07 16:11:53 riku Exp $ -->
