<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# hlo_tila tarkastusfunktiot

function hlo_tila_ok(&$msg,$id,$alue_id,$paivystys_id,$hlo_tila,$paikalla) {
  global $table, $prefix;
  
  $msg = '';
  $ret = 0;
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = true;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = false;
    $tail = " Ei voi list.";
  }

  $ret_p = permission_ids($msg,$alue_id,$paivystys_id);
  if ($ret_p == 2) {
    $msg .= $tail;
    return 2;
  } else {
    $ret = $ret_p;
  }
  
  # jos muutos, tarkastetaan ett on oikeus mys oleviin tietoihin
  if ($modify) {
    $w_alue_id = tab_col_id($table,"alue_id",$id);
    $w_paivystys_id = tab_col_id($table,"paivystys_id",$id);
    $ret_p = permission_ids($msg,$w_alue_id,$w_paivystys_id);
    if ($ret_p == 2) {
      $msg .= $tail;
      return 2;
    } else {
      $ret = $ret_p;
    }
  } # modify
  
  # kovakoodatut tietueet
  if (($id >= "1") && ($id <= "5")) {
    $msg = "Koodit numeroilla 1, 2, 3, 4 ja 5 on suojattu.";
    $msg .= $tail;
    return 2;
  }

  # tarpeelliset kentt
  if ($hlo_tila == '') {
    $msg = 'Tilakoodi on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # suojaus
  if ($modify && tab_col_id("hlo_tila","suojattu",$id) == 1) {
      $msg = "Tm tietue on suojattu.";
      $msg .= $tail;
      return 2;
  }

  if (!(($paikalla == 0) || ($paikalla = 1))) {
    $msg = "Paikalla oltava joko 1(ON) tai 0(EI).";
    $msg .= $tail;
    return 2;
  }
  
  # duplikaatit
  $dup =
    ota_yksi("SELECT id
              FROM $table
              WHERE hlo_tila = '$hlo_tila'
                    AND (paivystys_id = " . s("paivystys") . "
                         OR (paivystys_id = 2
                             AND alue_id = " . s("alue") . ")
                         OR alue_id = 2)
              $id_sql");
  if ($dup != '') {
    $msg = "Tllainen koodi on jo olemassa (id=$dup)";
    $msg .= $tail;
    return 2;
  } 

  return $ret;
}

function hlo_tila_add_ok(&$msg,$alue_id,$paivystys_id,$hlo_tila,$paikalla) {
  return hlo_tila_ok($msg,'',$alue_id,$paivystys_id,$hlo_tila,$paikalla);
}

function hlo_tila_save_ok(&$msg,$id,$alue_id,$paivystys_id,$hlo_tila,
			  $paikalla) {
  return hlo_tila_ok($msg,$id,$alue_id,$paivystys_id,$hlo_tila,$paikalla);
}

function hlo_tila_remove_ok(&$msg, $id, $log = true) {
  $msg = '';
  $ret = 0;

  $ret_p = permission_tab($msg, "hlo_tila", $id,$log);
  if ($ret_p == 2) {
    return 2;
  } else {
    $ret = $ret_p;
  }
  
  # kovakoodatut tietueet
  if (($id >= "1") && ($id <= "5")) {
    $msg = "Koodit numeroilla 1, 2, 3, 4 ja 5 on suojattu. Ei voi poistaa";
    return 2;
  }

  # suojattua ei voi poistaa
  if (tab_col_id("hlo_tila","suojattu",$id) == 1) {
    $msg = "Tm tietue on suojattu. Ei voi poistaa.";
    return 2;
  }

  # jos hlo_tilaan on viittauksia henkiliss
  # sit ei voi poistaa
  $ref =
    ota_yksi("SELECT COUNT(*)
              FROM hlo
              WHERE hlo_tila_id = $id");
  if ($ref != 0) {
    $msg = "Thn koodiin on viittauksia $ref eri henkilss. Sit ei voi
 poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }
  
  return $ret;
}

?>

<!-- RCS $Id: hlo_tila-ok.php,v 1.12 2009/04/18 16:06:56 riku Exp $ -->
