<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# kayttaja tarkastusfunktiot

function kayttaja_ok(&$msg,$id,$username,$root,$password,$hlo_id,$alue_ids,
		     $paivystys_ids) {
  global $table;
  
  $msg = '';
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # kovakoodatut tietueet
  if ($id == "1") {
    $msg = "Kyttj numero 1 on suojattu.";
    $msg .= $tail;
    return 2;
  }

  # tarpeelliset kentt
  if ($username === '') {
    $msg = 'Kyttjtunnus on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # henkiln oltava olemassa
  # tai soveltuvin osin 0
  if (tab_col_id_none("hlo","nimi",$hlo_id) == '') {
    $msg = "Henkil $hlo_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  
  # duplikaatit
  $dup = ota_yksi("
SELECT id
FROM $table
WHERE username = '$username'
      $id_sql
");
  if ($dup != '') {
    $msg = "Tm kyttjtunnus on jo olemassa (id=$dup)";
    $msg .= $tail;
    return 2;
  }

  # alueet
  foreach ($alue_ids as $alue_id) {
    if (tab_col_id("alue","id",$alue_id) == 0) {
      $msg = "Aluetta $alue_id ei lydy.";
      $msg .= $tail;
      return 2;
    }
  }
  
  # operaatiot
  foreach ($paivystys_ids as $paivystys_id) {
    if (tab_col_id("paivystys","id",$paivystys_id) == 0) {
      $msg = "Operaatiota $paivystys_id ei lydy.";
      $msg .= $tail;
      return 2;
    }
  }
  
  return 0;
}

function kayttaja_add_ok(&$msg,$username,$root,$password,$hlo_id,$alue_ids,
			 $paivystys_ids) {
  return kayttaja_ok($msg,'',$username,$root,$password,$hlo_id,$alue_ids,
		     $paivystys_ids);
}

function kayttaja_save_ok(&$msg,$id,$username,$root,$password,$hlo_id,
			  $alue_ids,$paivystys_ids) {
  return kayttaja_ok($msg,$id,$username,$root,$password,$hlo_id,$alue_ids,
		     $paivystys_ids);
}

function kayttaja_remove_ok(&$msg, $id, $log = true) {
  $msg = '';

  # kovakoodatut tietueet
  if ($id == "1") {
    $msg = "Kyttj numero 1 on suojattu. Ei voi poistaa";
    return 2;
  }

  # roottia ei voi poistaa
  if (tab_col_id("kayttajat","username",$id) == "root") {
    $msg = "Kyttjtunnusta 'root' ei voi poistaa.";
    return 2;
  }

  return 0;
}

?>

<!-- RCS $Id: kayttaja-ok.php,v 1.9 2009/03/15 13:58:29 riku Exp $ -->
