<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# laite_tyyppi tarkastusfunktiot

function laite_tyyppi_ok(&$msg,$id,$laite_tyyppi) {
  global $table;
  
  $msg = '';
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # kovakoodatut tietueet
  if ($id == "1") {
    $msg = "Koodi numero 1 on suojattu.";
    $msg .= $tail;
    return 2;
  }

  # tarpeelliset kentt
  if ($laite_tyyppi == '') {
    $msg = 'Tyyppikoodi on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # duplikaatit
  $dup = ota_yksi("
SELECT id
FROM $table
WHERE laite_tyyppi = '$laite_tyyppi'
      $id_sql
");
  if ($dup != '') {
    $msg = "Tllainen koodi on jo olemassa (id=$dup)";
    $msg .= $tail;
    return 2;
  } 

  return 0;
}

function laite_tyyppi_add_ok(&$msg,$laite_tyyppi) {
  return laite_tyyppi_ok($msg,'',$laite_tyyppi);
}

function laite_tyyppi_save_ok(&$msg,$id,$laite_tyyppi) {
  return laite_tyyppi_ok($msg,$id,$laite_tyyppi);
}

function laite_tyyppi_remove_ok(&$msg, $id, $log = true) {
  $msg = '';
  $ret = 0;

  # kovakoodattu
  if ($id == "1") {
    $msg = "Koodia numero 1 ei voi poistaa.";
    return 2;
  }

  # jos laite_tyyppiin on viittauksia laitteissa,
  # sit ei voi poistaa
  $ref = ota_yksi("
SELECT COUNT(*)
FROM laite
WHERE laite_tyyppi_id = $id
");
  if ($ref != 0) {
    $msg = "Thn koodiin on viittauksia $ref eri viestivlineess. Sit ei voi
 poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }
  
  return $ret;
}

?>

<!-- RCS $Id: laite_tyyppi-ok.php,v 1.4 2009/03/02 15:45:35 riku Exp $ -->
