<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# loytynyt tarkastusfunktiot
# here, we do not pass everything possible. only those fields there are
# some formal restrictions for.

function loytynyt_ok(&$msg,$id,$alue_id,$paivystys_id,$lapsi_tila_id,$kello,
		     $nimi,$soitettu_omaiselle_kello,$kuulutuspyynto1,
		     $kuulutuspyynto2,$kuulutuspyynto3,$kuulutuspyynto4,
		     $kuulutus1,$kuulutus2,$kuulutus3,$kuulutus4,
		     $loydetty_kello,$poliisi_kello,$loytaneet_kello) {
  global $table;
  
  $msg = '';
  $ret = 0;
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = true;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = false;
    $tail = " Ei voi list.";
  }

  $ret_p = permission_ids($msg,$alue_id,$paivystys_id);
  if ($ret_p == 2) {
    $msg .= $tail;
    return 2;
  } else {
    $ret = $ret_p;
  }

  # jos muutos, tarkastetaan ett on oikeus mys oleviin tietoihin
  if ($modify) {
    $w_alue_id = tab_col_id($table,"alue_id",$id);
    $w_paivystys_id = tab_col_id($table,"paivystys_id",$id);
    $ret_p = permission_ids($msg,$w_alue_id,$w_paivystys_id);
    if ($ret_p == 2) {
      $msg .= $tail;
      return 2;
    } else {
      $ret = $ret_p;
    }
  } # modify
  
  if ($nimi == '') {
    $msg = "Nimi ei voi olla tyhj.";
    $msg .= $tail;
    return 2;
  }
  if ($kello == '') {
    $msg = "Kellonaika ei voi olla tyhj.";
    $msg .= $tail;
    return 2;
  }
  
  if (tab_col_id("lapsi_tila","",$lapsi_tila_id) == '') {
    $msg = "Tilakoodia $lapsi_tila_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  # aikaleimat kunnollisia?
  if (timestamp_ok($kello) != 0) {
    $msg = "Aikaleima $kello ei kelpaa";
    $msg .= $tail;
    return 2;
  }
  if (timestamp_ok($soitettu_omaiselle_kello) != 0) {
    $msg = "Aikaleima $soitettu_omaiselle_kello ei kelpaa";
    $msg .= $tail;
    return 2;
  }
  if (timestamp_ok($kuulutuspyynto1) != 0) {
    $msg = "Aikaleima $kuulutuspyynto1 ei kelpaa";
    $msg .= $tail;
    return 2;
  }
  if (timestamp_ok($kuulutuspyynto2) != 0) {
    $msg = "Aikaleima $kuulutuspyynto2 ei kelpaa";
    $msg .= $tail;
    return 2;
  }
  if (timestamp_ok($kuulutuspyynto3) != 0) {
    $msg = "Aikaleima $kuulutuspyynto3 ei kelpaa";
    $msg .= $tail;
    return 2;
  }
  if (timestamp_ok($kuulutuspyynto4) != 0) {
    $msg = "Aikaleima $kuulutuspyynto4 ei kelpaa";
    $msg .= $tail;
    return 2;
  }
  if (timestamp_ok($kuulutus1) != 0) {
    $msg = "Aikaleima $kuulutus1 ei kelpaa";
    $msg .= $tail;
    return 2;
  }
  if (timestamp_ok($kuulutus2) != 0) {
    $msg = "Aikaleima $kuulutus2 ei kelpaa";
    $msg .= $tail;
    return 2;
  }
  if (timestamp_ok($kuulutus3) != 0) {
    $msg = "Aikaleima $kuulutus3 ei kelpaa";
    $msg .= $tail;
    return 2;
  }
  if (timestamp_ok($kuulutus4) != 0) {
    $msg = "Aikaleima $kuulutus4 ei kelpaa";
    $msg .= $tail;
    return 2;
  }
  if (timestamp_ok($loydetty_kello) != 0) {
    $msg = "Aikaleima $loydetty_kello ei kelpaa";
    $msg .= $tail;
    return 2;
  }
  if (timestamp_ok($poliisi_kello) != 0) {
    $msg = "Aikaleima $poliisi_kello ei kelpaa";
    $msg .= $tail;
    return 2;
  }
  if (timestamp_ok($loytaneet_kello) != 0) {
    $msg = "Aikaleima $loytaneet_kello ei kelpaa";
    $msg .= $tail;
    return 2;
  }

  # jos pivystys asetettu, tytyy tsmt alueeseen
  if ($paivystys_id > 2) {
    $paivystyksen_alue = tab_col_id("paivystys","alue_id",$paivystys_id);
    if (($paivystyksen_alue != 2) && ($paivystyksen_alue != $alue_id)) {
      $msg = "Alue($alue_id) ja operaatio($paivystys_id) eivt sovi yhteen.";
      $msg .= $tail;
      return 2;
    }
  }
  
  return $ret;
}

function loytynyt_add_ok(&$msg,$alue_id,$paivystys_id,$lapsi_tila_id,$kello,
			 $nimi,$soitettu_omaiselle_kello,$kuulutuspyynto1,
			 $kuulutuspyynto2,$kuulutuspyynto3,$kuulutuspyynto4,
			 $kuulutus1,$kuulutus2,$kuulutus3,$kuulutus4,
			 $loydetty_kello,$poliisi_kello,$loytaneet_kello) {
  return loytynyt_ok($msg,'',$alue_id,$paivystys_id,$lapsi_tila_id,$kello,
		     $nimi,$soitettu_omaiselle_kello,$kuulutuspyynto1,
		     $kuulutuspyynto2,$kuulutuspyynto3,$kuulutuspyynto4,
		     $kuulutus1,$kuulutus2,$kuulutus3,$kuulutus4,
		     $loydetty_kello,$poliisi_kello,$loytaneet_kello);
}

function loytynyt_save_ok(&$msg,$id,$alue_id,$paivystys_id,$lapsi_tila_id,
			  $kello,
			  $nimi,$soitettu_omaiselle_kello,$kuulutuspyynto1,
			  $kuulutuspyynto2,$kuulutuspyynto3,$kuulutuspyynto4,
			  $kuulutus1,$kuulutus2,$kuulutus3,$kuulutus4,
			  $loydetty_kello,$poliisi_kello,$loytaneet_kello) {
  return loytynyt_ok($msg,$id,$alue_id,$paivystys_id,$lapsi_tila_id,$kello,
		     $nimi,$soitettu_omaiselle_kello,$kuulutuspyynto1,
		     $kuulutuspyynto2,$kuulutuspyynto3,$kuulutuspyynto4,
		     $kuulutus1,$kuulutus2,$kuulutus3,$kuulutus4,
		     $loydetty_kello,$poliisi_kello,$loytaneet_kello);
}

function loytynyt0_add_ok(&$msg,$alue_id,$paivystys_id,$lapsi_tila_id,$kello,
			  $nimi) {
  return loytynyt_ok($msg,'',$alue_id,$paivystys_id,$lapsi_tila_id,$kello,$nimi,
		     '','','','','','','','','','','','');
}

function loytynyt0_save_ok(&$msg,$id,$alue_id,$paivystys_id,$lapsi_tila_id,
			   $kello,$nimi) {
  return loytynyt_ok($msg,$id,$alue_id,$paivystys_id,$lapsi_tila_id,$kello,
		     $nimi,
		     '','','','','','','','','','','','');
}

function loytynyt_remove_ok(&$msg, $id, $log = true) {
  global $table;
  
  $ret = 0;
  
  $ret_p = permission_tab($msg, $table, $id, $log);
  if ($ret_p == 2) {
    return 2;
  } else {
    $ret = $ret_p;
  }
  
  return $ret;
}

?>

<!-- RCS $Id: loytynyt-ok.php,v 1.5 2009/03/24 09:11:02 riku Exp $ -->
