<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# paikka tarkastusfunktiot

function paikka_ok(& $msg,$id,$alue_id,$paivystys_id,$paikka) {
  global $table, $prefix;
  
  $msg = '';
  $ret = 0;
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = true;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = false;
    $tail = " Ei voi list.";
  }

  $ret_p = permission_ids($msg,$alue_id,$paivystys_id);
  if ($ret_p == 2) {
    $msg .= $tail;
    return 2;
  } else {
    $ret = $ret_p;
  }

  # jos muutos, tarkastetaan ett on oikeus mys oleviin tietoihin
  if ($modify) {
    $w_alue_id = tab_col_id($table,"alue_id",$id);
    $w_paivystys_id = tab_col_id($table,"paivystys_id",$id);
    $ret_p = permission_ids($msg,$w_alue_id,$w_paivystys_id);
    if ($ret_p == 2) {
      $msg .= $tail;
      return 2;
    } else {
      $ret = $ret_p;
    }
  } # modify
  
  # kovakoodatut tietueet
  if (($id >= "1") && ($id <= "3")) {
    $msg = "Koodit 1, 2 ja 3 on suojattu.";
    $msg .= $tail;
    return 2;
  }

  # tarpeelliset kentt
  if ($paikka == '') {
    $msg = 'Sijaintikoodi on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # duplikaatit
  $dup =
    ota_yksi("SELECT id
              FROM $table
              WHERE paikka = '$paikka'
                    AND ((paivystys_id = " . s("paivystys") . ")
                    OR (paivystys_id = 2
                        AND alue_id = " . s("alue") . ")
                    OR alue_id = 2)
              $id_sql");
  if ($dup != '') {
    $msg = "Tllainen koodi on jo olemassa (id=$dup)";
    $msg .= $tail;
    return 2;
  } 

  return $ret;
}

function paikka_add_ok(&$msg,$alue_id,$paivystys_id,$paikka) {
  return paikka_ok($msg,'',$alue_id,$paivystys_id,$paikka);
}

function paikka_save_ok(&$msg,$id,$alue_id,$paivystys_id,$paikka) {
  return paikka_ok($msg,$id,$alue_id,$paivystys_id,$paikka);
}

function paikka_remove_ok(&$msg, $id, $log = true) {
  global $table;
  
  $msg = '';
  $ret = 0;

  $ret_p = permission_tab($msg, $table, $id, $log);
  if ($ret_p == 2) {
    return 2;
  } else {
    $ret = $ret_p;
  }

  # kovakoodatut tietueet
  if (($id >= "1") && ($id <= "3")) {
    $msg = "Koodit 1, 2 ja 3 on suojattu.";
    return 2;
  }

  # jos paikkaan on viittauksia ryhmiss
  # sit ei voi poistaa
  $ref = ota_yksi("
SELECT COUNT(*)
FROM ryhma
WHERE paikka_id = $id
");
  if ($ref != 0) {
    $msg = "Thn koodiin on viittauksia $ref eri ryhmss. Sit ei voi
 poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }
  
  return $ret;
}

?>

<!-- RCS $Id: paikka-ok.php,v 1.9 2009/04/18 16:06:56 riku Exp $ -->
