<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# ryhma tarkastusfunktiot
# HUOM: paikka_id vlitetn viitteell koska sit voidaan modifioida
# tarkastuksen kuluessa.
# HUOM: kaikkia tietoja ei vlitet tarkastettaviksi

function ryhma_ok(&$msg,$id,$alue_id,$paivystys_id,&$paikka_id,$ryhma_tila_id,
		  $verkko_id,$kutsu) {
  global $table, $prefix;
  
  $msg = '';
  $ret = 0;
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = true;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = false;
    $tail = " Ei voi list.";
  }

  $ret_p = permission_ids($msg,$alue_id,$paivystys_id);
  if ($ret_p == 2) {
    $msg .= $tail;
    return 2;
  } else {
    $ret = $ret_p;
  }
  
  # jos muutos, tarkastetaan ett on oikeus mys oleviin tietoihin
  if ($modify) {
    $w_alue_id = tab_col_id($table,"alue_id",$id);
    $w_paivystys_id = tab_col_id($table,"paivystys_id",$id);
    $ret_p = permission_ids($msg,$w_alue_id,$w_paivystys_id);
    if ($ret_p == 2) {
      $msg .= $tail;
      return 2;
    } else {
      $ret = $ret_p;
    }
  } # modify
  
  # kovakoodatut tietueet
  if ($id == "1") {
    $msg = "Ryhm numero 1 on suojattu.";
    $msg .= $tail;
    return 2;
  }

  # tarpeelliset kentt
  if ($kutsu == '') {
    $msg = 'Kutsu on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # oltava olemassa tai soveltuvin osin 0
  if (tab_col_id("paikka","",$paikka_id) == '') {
    $msg = "Sijaintikoodia $paikka_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("ryhma_tila","",$ryhma_tila_id) == '') {
    $msg = "Tilakoodia $ryhma_tila_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("verkko","",$verkko_id) == '') {
    $msg = "Verkkoa $verkko_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  
  # duplikaatit
  $dup =
    ota_yksi("SELECT id
              FROM ryhma
              WHERE kutsu = '$kutsu'
              AND (paivystys_id = " . s("paivystys") . "
                   OR (paivystys_id = 2 AND alue_id = " . s("alue") . ")
                   OR alue_id = 2)
              $id_sql");
  if ($dup != '') {
    $msg = "Ryhm $kutsu on jo olemassa (id=$dup).";
    $msg .= $tail;
    return 2;
  }

  # jos paikka ei sovi yhteen paivystys_id:n kanssa, resetoi se.
  $paikka_paivystys_id
    = ota_yksi("SELECT paivystys_id FROM paikka WHERE id = $paikka_id");
  if ($paikka_paivystys_id != 2) {
    if ($paivystys_id != 2) {
      if ($paivystys_id != $paikka_paivystys_id) {
	$paikka_id = "1";
	$msg .= " Sijainti vaihdettu.";
	$ret = 1;
      }
    }
  }

  if ($modify) {
    # niss ei ole jrke ellei modifioida olemassaolevaa.
    
    # jos ryhmss on henkilkuntaa, vaihdetaan heilt pivystys jos tarpeen.
    $count1 =
      ota_yksi("SELECT COUNT(*)
                FROM hlo
                WHERE ryhma_id = $id AND paivystys_id != $paivystys_id");
    if ($count1 != 0) {
      $now = date('Y-m-d H:i:s');
      $sql1 =
	"UPDATE hlo
         SET paivystys_id = $paivystys_id, ts = '$now'
         WHERE ryhma_id=$id";
     my_mysql_query($sql1);
     loki($sql1);
     $msg .= " $count1 henkiln operaatio vaihdettu automaattisesti.";
     $ret = 1;
    }
    # jos ryhmss on laitteita tai tavaraa,
    # vaihdetaan niiltkin pivystys jos tarpeen.
    $count1 =
      ota_yksi("SELECT COUNT(*)
                FROM laite
                WHERE ryhma_id=$id AND paivystys_id != $paivystys_id");
    if ($count1 != 0) {
      $now = date('Y-m-d H:i:s');
      $sql1 =
        "UPDATE laite
         SET paivystys_id = $paivystys_id, ts = '$now'
         WHERE ryhma_id=$id";
      my_mysql_query($sql1);
      loki($sql1);
      $msg .= " $count1 viestivlineen operaatio vaihdettu automaattisesti.";
      $ret = 1;
    }
    $count1 =
      ota_yksi("SELECT COUNT(*)
                FROM tavara
                WHERE ryhma_id=$id AND paivystys_id != $paivystys_id");
   if ($count1 != 0) {
     $now = date('Y-m-d H:i:s');
     $sql1 =
       "UPDATE tavara
        SET paivystys_id = $paivystys_id, ts = '$now'
        WHERE ryhma_id=$id AND paivystys_id != $paivystys_id";
     my_mysql_query($sql1);
     loki($sql1);
     $msg .= " $count1 tavaran operaatio vaihdettu automaattisesti.";
     $ret = 1;
   }
  } # if modify
  
  return $ret;
}

function ryhma_add_ok(&$msg,$alue_id,$paivystys_id,&$paikka_id,$ryhma_tila_id,
		      $verkko_id,$kutsu) {
  return ryhma_ok($msg,'',$alue_id,$paivystys_id,$paikka_id,$ryhma_tila_id,
		  $verkko_id,$kutsu);
}

function ryhma_save_ok(&$msg,$id,$alue_id,$paivystys_id,&$paikka_id,
		       $ryhma_tila_id,$verkko_id,$kutsu) {
  return ryhma_ok($msg,$id,$alue_id,$paivystys_id,$paikka_id,$ryhma_tila_id,
		  $verkko_id,$kutsu);
}

function ryhma_set_ryhma_tila_id_ok(&$msg,$id,$ryhma_tila_id) {
  $alue_id = tab_col_id("ryhma","alue_id",$id);
  $paivystys_id = tab_col_id("ryhma","paivystys_id",$id);
  $paikka_id = tab_col_id("ryhma","paikka_id",$id);
  $verkko_id = tab_col_id("ryhma","verkko_id",$id);
  $kutsu = tab_col_id("ryhma","kutsu",$id);
  return ryhma_ok($msg,$id,$alue_id,$paivystys_id,$paikka_id,$ryhma_tila_id,
		  $verkko_id,$kutsu);
}

function ryhma_set_paikka_id_ok(&$msg,$id,$paikka_id) {
  $alue_id = tab_col_id("ryhma","alue_id",$id);
  $paivystys_id = tab_col_id("ryhma","paivystys_id",$id);
  $ryhma_tila_id = tab_col_id("ryhma","ryhma_tila_id",$id);
  $verkko_id = tab_col_id("ryhma","verkko_id",$id);
  $kutsu = tab_col_id("ryhma","kutsu",$id);
  return ryhma_ok($msg,$id,$alue_id,$paivystys_id,$paikka_id,$ryhma_tila_id,
		  $verkko_id,$kutsu);
}

function ryhma_set_ok(&$msg,$id) {
  $alue_id = tab_col_id("ryhma","alue_id",$id);
  $paivystys_id = tab_col_id("ryhma","paivystys_id",$id);
  $paikka_id = tab_col_id("ryhma","paikka_id",$id);
  $ryhma_tila_id = tab_col_id("ryhma","ryhma_tila_id",$id);
  $verkko_id = tab_col_id("ryhma","verkko_id",$id);
  $kutsu = tab_col_id("ryhma","kutsu",$id);
  return ryhma_ok($msg,$id,$alue_id,$paivystys_id,$paikka_id,$ryhma_tila_id,
		  $verkko_id,$kutsu);
}

function ryhma_remove_ok(&$msg, $id, $log = true) {
  global $table;
  
  $msg = '';
  $ret = 0;

  $ret_p = permission_tab($msg, $table, $id, $log);
  if ($ret_p == 2) {
    return 2;
  } else {
    $ret = $ret_p;
  }

  # kovakoodattu
  if ($id == "1") {
    $msg = "Ryhm numero 1 ei voi poistaa.";
    return 2;
  }

  # jos ryhmss on henkilkuntaa, tapahtumia, laitteita tai tavaraa
  # sit ei voi poistaa
  $vahvuus = ota_yksi("SELECT COUNT(*) FROM hlo WHERE ryhma_id = $id");
  if ($vahvuus != 0) {
    $msg = "Ryhmss on viel $vahvuus henkil eik ryhm voi poistaa ennen
 kuin nm henkilt on poistettu ryhmst.";
    return 2;
  }
  $tap = ota_yksi("SELECT COUNT(*) FROM tap WHERE ryhma_id = $id");
  if ($tap != 0) {
    $msg = "Ryhmlle on viel kirjattuna $tap tapahtumaa eik ryhm voi
 poistaa ennen kuin nm tapahtumat on poistettu ryhmlt.";
    return 2;
  }
  $laite = ota_yksi("SELECT COUNT(*) FROM laite WHERE ryhma_id = $id");
  if ($laite != 0) {
    $msg = "Ryhmll on viel hallussa $laite viestivlinett eik ryhm voi
 poistaa ennen kuin nm on poistettu ryhmlt.";
    return 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM tavara WHERE ryhma_id = $id");
  if ($ref != 0) {
    $msg = "Ryhmll on viel hallussa $ref tavaraa eik ryhm voi
 poistaa ennen kuin nm on poistettu ryhmlt.";
    return 2;
  }
  
  return $ret;
}

?>

<!-- RCS $Id: ryhma-ok.php,v 1.20 2009/04/20 10:57:47 riku Exp $ -->
