<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# ryhna_tila tarkastusfunktiot

function ryhma_tila_ok(&$msg,$id,$alue_id,$paivystys_id,$ryhma_tila) {
  global $table, $prefix;
  
  $msg = '';
  $ret = 0;
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = true;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = false;
    $tail = " Ei voi list.";
  }

  $ret_p = permission_ids($msg,$alue_id,$paivystys_id);
  if ($ret_p == 2) {
    $msg .= $tail;
    return 2;
  } else {
    $ret = $ret_p;
  }
  
  # jos muutos, tarkastetaan ett on oikeus mys oleviin tietoihin
  if ($modify) {
    $w_alue_id = tab_col_id($table,"alue_id",$id);
    $w_paivystys_id = tab_col_id($table,"paivystys_id",$id);
    $ret_p = permission_ids($msg,$w_alue_id,$w_paivystys_id);
    if ($ret_p == 2) {
      $msg .= $tail;
      return 2;
    } else {
      $ret = $ret_p;
    }
  } # modify
  
  # kovakoodatut tietueet
  if (($id == "1") || ($id == "2") || ($id == "8") || ($id == "11") ||
      ($id == "12")) {
    $msg = "Koodit numero 1, 2, 8, 11 ja 12 on suojattu.";
    $msg .= $tail;
    return 2;
  }

  # suojaus
  if ($modify) {
    if (tab_col_id("ryhma_tila","suojattu",$id) == 1) {
      $msg = "Tm tietue on suojattu.";
      $msg .= $tail;
      return 2;
    }
  }

  # tarpeelliset kentt
  if ($ryhma_tila == '') {
    $msg = 'Tilakoodi on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # duplikaatit
  $dup =
    ota_yksi("SELECT id
              FROM $table
              WHERE ryhma_tila = '$ryhma_tila'
                    AND (paivystys_id = " . s("paivystys") . "
                         OR (paivystys_id = 2
                             AND alue_id = " . s("alue") . ")
                         OR alue_id = 2)
              $id_sql");
  if ($dup != '') {
    $msg = "Tllainen koodi on jo olemassa (id=$dup)";
    $msg .= $tail;
    return 2;
  } 

  return $ret;
}

function ryhma_tila_add_ok(&$msg,$alue_id,$paivystys_id,$ryhma_tila) {
  return ryhma_tila_ok($msg,'',$alue_id,$paivystys_id,$ryhma_tila);
}

function ryhma_tila_save_ok(&$msg,$id,$alue_id,$paivystys_id,$ryhma_tila) {
  return ryhma_tila_ok($msg,$id,$alue_id,$paivystys_id,$ryhma_tila);
}

function ryhma_tila_remove_ok(&$msg, $id, $log = true) {
  global $table;
  
  $msg = '';
  $ret = 0;

  $ret_p = permission_tab($msg, $table, $id, $log);
  if ($ret_p == 2)
    return 2;
  $ret = $ret_p;
  
  # kovakoodatut tietueet
  if (($id == "1") || ($id == "2") || ($id == "8") || ($id == "11") ||
      ($id == "12")) {
    $msg = "Koodit numero 1, 2, 8, 11 ja 12 on suojattu.";
    return 2;
  }

  # suojattua ei voi poistaa
  if (tab_col_id("ryhma_tila","suojattu",$id) == 1) {
    $msg = "Tm tietue on suojattu. Ei voi poistaa.";
    return 2;
  }

  # jos hlo_tilaan on viittauksia henkiliss
  # sit ei voi poistaa
  $ref =
    ota_yksi("SELECT COUNT(*)
              FROM ryhma
              WHERE ryhma_tila_id = $id");
  if ($ref != 0) {
    $msg = "Thn koodiin on viittauksia $ref eri ryhmss. Sit ei voi "
      . "poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }
  
  return $ret;
}

?>

<!-- RCS $Id: ryhma_tila-ok.php,v 1.7 2009/04/18 16:06:56 riku Exp $ -->
