<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# tap tarkastusfunktiot

function tap_ok(&$msg,$id,$alue_id,$paivystys_id,$ryhma_id,$tap) {
  $table = "tap";

  $msg = '';
  $ret = 0;
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = true;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = false;
    $tail = " Ei voi list.";
  }

  $ret_p = permission_ids($msg,$alue_id,$paivystys_id);
  if ($ret_p == 2) {
    $msg .= $tail;
    return 2;
  } else {
    $ret = $ret_p;
  }
  
  # jos muutos, tarkastetaan ett on oikeus mys oleviin tietoihin
  if ($modify) {
    $w_alue_id = tab_col_id($table,"alue_id",$id);
    $w_paivystys_id = tab_col_id($table,"paivystys_id",$id);
    $ret_p = permission_ids($msg,$w_alue_id,$w_paivystys_id);
    if ($ret_p == 2) {
      $msg .= $tail;
      return 2;
    } else {
      $ret = $ret_p;
    }
  } # modify
  
  # tarpeelliset kentt
  if ($tap == '') {
    $msg = 'Tapahtumakirjaus tarvitaan.';
    $msg .= $tail;
    return 2;
  }

  # ryhma oltava olemassa
  if (tab_col_id("ryhma","kutsu",$ryhma_id) == '') {
    $msg = "Ryhm $ryhma_id ei lydy.";
    $msg .= $tail;
    return 2;
  }

  # ryhman alue ja pivystys pit tsmt
  $ryhma_alue_id = tab_col_id("ryhma","alue_id",$ryhma_id);
  if ($ryhma_alue_id != $alue_id) {
    $msg =
      "Ryhmn ja tapahtuman alueet eivt tsm ($ryhma_alue_id != $alue_id)";
    $msg .= $tail;
    return 2;
  }
  $ryhma_paivystys_id = tab_col_id("ryhma","paivystys_id",$ryhma_id);
  if ($ryhma_paivystys_id != $paivystys_id) {
    $msg =
      "Ryhmn ja tapahtuman operaatiot eivt tsm "
      . "($ryhma_paivystys_id != $paivystys_id)";
    $msg .= $tail;
    return 2;
  }
  
  # duplikaatteja voi olla
  
  return $ret;
}

function tap_add_ok(&$msg,$alue_id,$paivystys_id,$ryhma_id,$tap) {
  return tap_ok($msg,'',$alue_id,$paivystys_id,$ryhma_id,$tap);
}

function tap_save_ok(&$msg,$id,$alue_id,$paivystys_id,$ryhma_id,$tap) {
  return tap_ok($msg,$id,$alue_id,$paivystys_id,$ryhma_id,$tap);
}

function tap_remove_ok(&$msg, $id, $log = true) {
  global $table;

  $ret = 0;
  
  $ret_p = permission_tab($msg, $table, $id, $log);
  if ($ret_p == 2) {
    return 2;
  } else {
    $ret = $ret_p;
  }
  
  return $ret;
}

?>

<!-- RCS $Id: tap-ok.php,v 1.6 2009/03/25 09:31:47 riku Exp $ -->
