<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

$file = basename(__FILE__);

include "common.php";

echo "
<html>
<head>
 <title>VIHA - Tilanne</title>
 <meta HTTP-EQUIV=\"Refresh\" CONTENT=120></head>
" . body_bgcolor() . "
";

$conf = get_nro('conf');
if ($conf == '') {
  $conf = s('tilanne0-conf');
} else {
  $_SESSION[$prefix . 'tilanne0-conf'] = $conf;
}

switch ($conf) {
 case 1:
   $columns = 3;
   $bottom = 1;
   $side = 0;
   break;
 case 2:
   $columns = 4;
   $bottom = 1;
   $side = 1;
   break;
 default:
   $columns = 2;
   $bottom = 0;
   $side = 0;
   break;
 }

$now = date('Y-m-d H:i:s');

oltava_useita($file);

echo "<h1>Kaikki operaatiot, tilanne, $now</h1>\n";

echo "<p>V = Ryhmn vahvuus, K = ryhmll olevien kirjausten mr,
[V] = Verkko, [K] = koordinaatit\n";

if ($bottom == 0) {
  taktiset_linkit();
}

$sql =
  "SELECT id, alue_id, nimi, oletus_verkko_id
   FROM paivystys
   WHERE id > 2
   ORDER BY alue_id, nimi";
$result = my_mysql_query($sql);
if ($result) {
  while ($a = mysql_fetch_array($result)) {
    # just skip those items we do not have permission to
    if (permission_ids($herja,$a['alue_id'],$a['id'],false) == 2)
      continue; 
    nayta_paivystys($a['alue_id'],$a['id'],$a['nimi'],$a['oletus_verkko_id']);
  }
}

function nayta_paivystys($alue_id, $p_id, $p_nimi, $p_oletus_verkko_id)
{
  global $columns, $bottom, $side, $prefix;
  
  echo "<p><big>" . tab_col_id("alue","",$alue_id)
    . ", $p_nimi</big>, oletusverkko: "
    . ota_yksi("SELECT verkko FROM verkko WHERE id = $p_oletus_verkko_id")
    . ", kadonneita " . ota_kadonneet_paivystys($p_id)
    . ", lytyneit " . ota_loytyneet_paivystys($p_id)
    . ", vahvuus " . ota_vahvuus($p_id)
    . " joista paikalla " . ota_paikalla($p_id);
  $items =
    ota_yksi("SELECT COUNT(*)
              FROM ryhma,paikka,ryhma_tila,verkko
              WHERE ryhma_tila_id = ryhma_tila.id AND paikka_id = paikka.id
                    AND verkko_id = verkko.id
              AND (ryhma.paivystys_id = $p_id
                   OR (ryhma.alue_id = $alue_id AND ryhma.paivystys_id = 2)
                   OR ryhma.alue_id = 2)
              ORDER BY pri");
  $percol = intval(floor(($items + $columns - 1) / $columns));
  $sql =
    "SELECT ryhma.id,kutsu,koordinaatit,ryhma_tila,paikka,verkko
     FROM ryhma,paikka,ryhma_tila,verkko
     WHERE ryhma_tila_id = ryhma_tila.id AND paikka_id = paikka.id
           AND verkko_id = verkko.id
           AND (ryhma.paivystys_id = $p_id
                OR (ryhma.alue_id = $alue_id AND ryhma.paivystys_id = 2)
                OR ryhma.alue_id = 2)
     ORDER BY pri";
  $result = my_mysql_query($sql);
  if ($result) {
    echo "
<table align=top>
  <tr valign=top>";
    $n = 0;
    while ($a = mysql_fetch_array($result)) {
      if (($n % $percol) == 0) {
	echo "
  <td align=top>
  <table border=1>"
	  . tr_bgcolor()
	  . "<th>Ryhm [V]<th>Tila<th>Sijainti [K]<th>V<th>K\n";
      }
      $a_id = $a['id'];
      $vahv = ota_yksi("
SELECT COUNT(*)
FROM hlo
WHERE ryhma_id = $a_id
      AND paivystys_id = $p_id
");
      $kirj = ota_yksi("
SELECT COUNT(*)
FROM tap
WHERE ryhma_id = $a_id
");
      echo "    <tr>";
      $kutsuverkko = "$a[kutsu]"
	. muotoile_verkko_paivystys($a['verkko'], $a['id'], $p_id);
      # linkit nytetn vain aktiiviselle pivystykselle
      if ($p_id == s('paivystys')) {
	echo "<TD><a href=\"tilanne-taysi.php?id=$a_id\">$kutsuverkko</a>";
	echo "<TD><a href=\"ryhma-takt-1.php?id=$a_id\">$a[ryhma_tila]</a>";
      } else {
	echo "<TD>$kutsuverkko";
	echo "<TD>$a[ryhma_tila]";
      }
      echo "<TD>$a[paikka]", muotoile_koordinaatit($a['koordinaatit']),
	"<TD>$vahv",
	"<td>$kirj";
      if ((($n % $percol) == ($percol - 1))
	  || ($n == ($items - 1))) {
	echo "
  </table>\n";
      }
      $n ++;
    }
    echo "
</TABLE>\n";
  }
}

echo "<p>Tapahtumapivkirja, kymmenen tuoreinta, uusimmat ensin";
$nayta_kpl = 10;
$naytetty = 0;
$result =
  my_mysql_query("SELECT taktinen_loki.id,taktinen_loki.data,
                         taktinen_loki.ip,taktinen_loki.user,taktinen_loki.ts,
                         paivystys.nimi,paivystys.id AS pid
                  FROM taktinen_loki,paivystys
                  WHERE taktinen_loki.paivystys_id = paivystys.id
                  ORDER BY taktinen_loki.ts DESC");
if ($result) {
  echo "<TABLE BORDER=1>\n";
  echo tr_bgcolor()
    . "<TH>Kello<TH>Tunnus<TH>Operaatio<TH>Tapahtuma\n";
  while ($a = mysql_fetch_array($result)) {
    # skip if no permission
    if (paivystys_id_ok($herja,$a['pid']) == 2)
      continue;
    echo "<TR>",
      "<TD align=right>" . vain_hhmm($a['ts']),
      "<TD>$a[user]",
      "<TD>$a[nimi]",
      "<TD>$a[data]";
    $naytetty ++;
    if ($naytetty >= $nayta_kpl)
      break;
  }
  echo "</TABLE>";
 } else {
  echo "<P>Plop. Ei lokia.";
 }
    
if ($bottom == 1) {
  taktiset_linkit();
}

echo "
<ul>Vaihtoehtoisia nkymi thn sivuun
<li><a href=\"tilanne0.php?conf=0\">
 Ryhmt 2 sarakkeessa,
 kadonneet ja lytyneet perkkin,
 linkit ylhll (oletus)
 </a>
<li><a href=\"tilanne0.php?conf=1\">
 Ryhmt 3 sarakkeessa,
 kadonneet ja lytyneet perkkin,
 linkit alhaalla
 </a>
<li><a href=\"tilanne0.php?conf=2\">
 Ryhmt 4 sarakkeessa,
 kadonneet ja lytyneet rinnakkain,
 linkit alhaalla
 </a>
</ul>

<p>Tm sivu pivittyy automaattisesti kahden minuutin vlein.
";

loppu();

?>

</body> 
</html>
<!-- RCS $Id: tilanne0.php,v 1.10 2009/04/18 14:51:47 riku Exp $ -->
