<?php

# Copyright (C) 2009 Riku Kalinen
# License conditions in the file lisenssi.html
# Lisenssiehdot tiedostossa lisenssi.html

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# verkko tarkastusfunktiot

function verkko_ok(&$msg,$id,$verkko) {
  global $table;
  
  $msg = '';
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # tarpeelliset kentt
  if ($verkko == '') {
    $msg = 'Verkko on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # duplikaatit
  $dup =
    ota_yksi("SELECT id
              FROM $table
              WHERE verkko = '$verkko'
              $id_sql");
  if ($dup != '') {
    $msg = "Tllainen verkko on jo olemassa (id=$dup)";
    $msg .= $tail;
    return 2;
  } 

  return 0;
}

function verkko_add_ok(&$msg,$verkko) {
  return verkko_ok($msg,'',$verkko);
}

function verkko_save_ok(&$msg,$id,$verkko) {
  return verkko_ok($msg,$id,$verkko);
}

function verkko_remove_ok(&$msg, $id, $log = true) {
  $msg = '';

  # jos verkkoon on viittauksia paivystyksissa, ryhmissa tai laitteissa,
  # sit ei voi poistaa
  $ref =
    ota_yksi("SELECT COUNT(*)
              FROM paivystys
              WHERE oletus_verkko_id = $id");
  if ($ref != 0) {
    $msg = "Thn verkkoon on viittauksia $ref eri operaatiossa. Sit ei voi
 poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM ryhma WHERE verkko_id = $id");
  if ($ref != 0) {
    $msg = "Thn verkkoon on viittauksia $ref eri ryhmss. Sit ei voi
 poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM laite WHERE verkko_id = $id");
  if ($ref != 0) {
    $msg = "Thn verkkoon on viittauksia $ref eri viestivlineess.
 Sit ei voi poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }
  
  return 0;
}

?>

<!-- RCS $Id: verkko-ok.php,v 1.3 2009/03/19 17:29:22 riku Exp $ -->
